=== modified file 'DBUS-API'
--- DBUS-API	2011-11-26 23:08:17 +0000
+++ DBUS-API	2011-11-24 19:09:29 +0000
@@ -112,7 +112,7 @@
       Disable().
    
    f) The date and time this client will be disabled, as an RFC 3339
-      string, or an empty string if this is not scheduled.
+      string, or an empty string if this has not happened.
    
    g) The date and time of the last approval request, as an RFC 3339
       string, or an empty string if this has not happened.

=== modified file 'Makefile'
--- Makefile	2011-12-21 00:33:12 +0000
+++ Makefile	2011-11-26 22:22:20 +0000
@@ -255,7 +255,7 @@
 	@echo "###################################################################"
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
 		$(CLIENTARGS)
 
 # Used by run-client
@@ -328,8 +328,6 @@
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
 	fi
-	install --mode=u=rwx,go=rx --directory \
-		"$(CONFDIR)/network-hooks.d"
 	install --mode=u=rwx,go=rx \
 		--target-directory=$(PREFIX)/lib/mandos plugin-runner
 	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \

=== modified file 'TODO'
--- TODO	2011-12-25 00:43:51 +0000
+++ TODO	2011-11-09 17:16:03 +0000
@@ -1,11 +1,12 @@
 -*- org -*-
 
+* Use _attribute_((nonnull)) wherever possible.
+
 * [[http://www.undeadly.org/cgi?action=article&sid=20110530221728][OpenBSD]]
 
 * mandos-applet
 
 * mandos-client
-** TODO [#A] Wireless network hook
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use struct sockaddr_storage instead of a union
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
@@ -39,20 +40,21 @@
 ** TODO [#B] Use openat()
 
 * mandos (server)
-** TODO Document why we ignore sigint
 ** TODO [#B] Log level							  :BUGS:
+  
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
 ** TODO [#C] config for TXT record
-** TODO Log level dbus option
-   SetLogLevel D-Bus call
+** TODO Log level option
+   syslogger.setLevel(logging.WARNING)
+   + SetLogLevel D-Bus call
 ** TODO Implement --foreground						  :BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO [#C] DBusServiceObjectUsingSuper
 ** TODO [#B] Global enable/disable flag
-** TODO [#B] By-client countdown on number of secrets given
+** TODO [#B] By-client countdown on secrets given
 ** TODO [#B] Support RFC 3339 time duration syntax
 ** More D-Bus methods
 *** NeedsPassword(50) - Timeout, default disapprove
@@ -68,7 +70,6 @@
 ** TODO Generate Client.runtime_expansions from client options + extra
 ** TODO Allow %%(checker)s as a runtime expansion
 ** TODO Use python-tlslite?
-** TODO D-Bus AddClient() method on server object
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -77,6 +78,7 @@
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
 ** TODO Support RFC 3339 time duration syntax
+** TODO Send milliseconds if bare integer is passed as time duration
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'clients.conf'
--- clients.conf	2011-11-26 23:08:17 +0000
+++ clients.conf	2011-09-19 09:42:55 +0000
@@ -30,9 +30,6 @@
 # How long one approval will last.
 ;approval_duration = 1s
 
-# Whether this client is enabled by default
-;enabled = True
-
 
 ;####
 ;# Example client

=== modified file 'debian/control'
--- debian/control	2011-12-21 17:09:12 +0000
+++ debian/control	2011-11-26 20:59:56 +0000
@@ -38,7 +38,7 @@
 Package: mandos-client
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools
+	gnupg (<< 2)
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup
 Description: do unattended reboots with an encrypted root file system

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2011-11-28 22:15:04 +0000
+++ debian/mandos-client.README.Debian	2011-10-05 16:00:56 +0000
@@ -51,11 +51,6 @@
   disk environment, the network interface *must* exist at that stage.
   Thus, the interface can *not* be a pseudo-interface such as "br0" or
   "tun0"; instead, only real interface (such as "eth0") can be used.
-  This can be overcome by writing a "network hook" program to create
-  the interface (see mandos-client(8mandos)) and placing it in
-  "/etc/mandos/network-hooks.d", from where it will be copied into the
-  initial RAM disk.  Example network hook scripts can be found in
-  "/usr/share/doc/mandos-client/network-hooks.d".
 
 * User-Supplied Plugins
   
@@ -89,4 +84,4 @@
   work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
   to be manually added to the file "/etc/mandos/plugin-runner.conf".
 
- -- Teddy Hogeborn <teddy@recompile.se>, Mon, 28 Nov 2011 23:07:22 +0100
+ -- Teddy Hogeborn <teddy@recompile.se>, Wed,  5 Oct 2011 17:50:22 +0200

=== modified file 'debian/mandos-client.docs'
--- debian/mandos-client.docs	2011-11-27 02:32:20 +0000
+++ debian/mandos-client.docs	2008-10-18 11:17:22 +0000
@@ -1,4 +1,3 @@
 NEWS
 README
 TODO
-network-hooks.d

=== modified file 'debian/rules'
--- debian/rules	2011-11-27 14:44:28 +0000
+++ debian/rules	2010-09-09 18:16:14 +0000
@@ -85,8 +85,7 @@
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/clients.conf \
 		--exclude etc/mandos/plugins.d \
-		--exclude usr/lib/mandos/plugins.d \
-		--exclude /usr/share/doc/mandos-client/network-hooks.d
+		--exclude usr/lib/mandos/plugins.d
 	dh_installdeb
 	dh_shlibdeps
 	dh_gencontrol

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2011-11-29 18:19:31 +0000
+++ initramfs-tools-hook	2011-10-05 16:56:06 +0000
@@ -68,11 +68,10 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
+	"${DESTDIR}${MANDOSDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -107,46 +106,6 @@
     esac
 done
 
-# Get DEVICE from initramfs.conf and other files
-. /etc/initramfs-tools/initramfs.conf
-for conf in /etc/initramfs-tools/conf.d/*; do
-    if [ -n `basename \"$conf\" | grep '^[[:alnum:]][[:alnum:]\._-]*$' \
-	| grep -v '\.dpkg-.*$'` ]; then
-	[ -f ${conf} ] && . ${conf}
-    fi
-done
-export DEVICE
-
-# Copy network hooks
-for hook in /etc/mandos/network-hooks.d/*; do
-    case "`basename \"$hook\"`" in
-	"*") continue ;;
-	*[!A-Za-z0-9_.-]*) continue ;;
-	*) test -d "$hook" || copy_exec "$hook" "${HOOKDIR}" ;;
-    esac
-    if [ -x "$hook" ]; then
-        # Copy any files needed by the network hook
-	MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=files \
-	    VERBOSITY=0 "$hook" files | while read file target; do
-	    if [ ! -e "${file}" ]; then
-		echo "WARNING: file ${file} not found, requested by Mandos network hook '${hook##*/}'" >&2
-	    fi
-	    if [ -z "${target}" ]; then
-		copy_exec "$file"
-	    else
-		copy_exec "$file" "$target"
-	    fi
-	done
-        # Copy and load any modules needed by the network hook
-	MANDOSNETHOOKDIR=/etc/mandos/network-hooks.d MODE=modules \
-	    VERBOSITY=0 "$hook" modules | while read module; do
-	    if [ -z "${target}" ]; then
-		force_load "$module"
-	    fi
-	done
-    fi
-done
-
 # GPGME needs /usr/bin/gpg
 if [ ! -e "${DESTDIR}/usr/bin/gpg" \
     -a -n "`ls \"${DESTDIR}\"/usr/lib/libgpgme.so* \

=== modified file 'mandos'
--- mandos	2011-12-23 20:00:52 +0000
+++ mandos	2011-11-26 22:22:20 +0000
@@ -85,6 +85,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
+
 version = "1.4.1"
 stored_state_file = "clients.pickle"
 
@@ -110,7 +111,7 @@
         return interface_index
 
 
-def initlogger(debug, level=logging.WARNING):
+def initlogger(level=logging.WARNING):
     """init logger and add loglevel"""
     
     syslogger.setFormatter(logging.Formatter
@@ -118,22 +119,20 @@
                             ' %(message)s'))
     logger.addHandler(syslogger)
     
-    if debug:
-        console = logging.StreamHandler()
-        console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
-                                               ' [%(process)d]:'
-                                               ' %(levelname)s:'
-                                               ' %(message)s'))
-        logger.addHandler(console)
+    console = logging.StreamHandler()
+    console.setFormatter(logging.Formatter('%(asctime)s %(name)s'
+                                           ' [%(process)d]:'
+                                           ' %(levelname)s:'
+                                           ' %(message)s'))
+    logger.addHandler(console)
     logger.setLevel(level)
 
 
-class PGPError(Exception):
-    """Exception if encryption/decryption fails"""
+class CryptoError(Exception):
     pass
 
 
-class PGPEngine(object):
+class Crypto(object):
     """A simple class for OpenPGP symmetric encryption & decryption"""
     def __init__(self):
         self.gnupg = GnuPGInterface.GnuPG()
@@ -185,7 +184,7 @@
                     ciphertext = f.read()
                 proc.wait()
             except IOError as e:
-                raise PGPError(e)
+                raise CryptoError(e)
         self.gnupg.passphrase = None
         return ciphertext
     
@@ -202,7 +201,7 @@
                     decrypted_plaintext = f.read()
                 proc.wait()
             except IOError as e:
-                raise PGPError(e)
+                raise CryptoError(e)
         self.gnupg.passphrase = None
         return decrypted_plaintext
 
@@ -378,7 +377,7 @@
                                 % self.name))
         return ret
 
-def timedelta_to_milliseconds(td):
+def _timedelta_to_milliseconds(td):
     "Convert a datetime.timedelta() to milliseconds"
     return ((td.days * 24 * 60 * 60 * 1000)
             + (td.seconds * 1000)
@@ -388,7 +387,7 @@
     """A representation of a client host served by this server.
     
     Attributes:
-    approved:   bool(); 'None' if not yet approved/disapproved
+    _approved:   bool(); 'None' if not yet approved/disapproved
     approval_delay: datetime.timedelta(); Time to wait for approval
     approval_duration: datetime.timedelta(); Duration of one approval
     checker:    subprocess.Popen(); a running checker process used
@@ -412,10 +411,11 @@
     interval:   datetime.timedelta(); How often to start a new checker
     last_approval_request: datetime.datetime(); (UTC) or None
     last_checked_ok: datetime.datetime(); (UTC) or None
+
     last_checker_status: integer between 0 and 255 reflecting exit
                          status of last checker. -1 reflects crashed
                          checker, or None.
-    last_enabled: datetime.datetime(); (UTC) or None
+    last_enabled: datetime.datetime(); (UTC)
     name:       string; from the config file, used in log messages and
                         D-Bus identifiers
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -431,107 +431,72 @@
                           "created", "enabled", "fingerprint",
                           "host", "interval", "last_checked_ok",
                           "last_enabled", "name", "timeout")
-    client_defaults = { "timeout": "5m",
-                        "extended_timeout": "15m",
-                        "interval": "2m",
-                        "checker": "fping -q -- %%(host)s",
-                        "host": "",
-                        "approval_delay": "0s",
-                        "approval_duration": "1s",
-                        "approved_by_default": "True",
-                        "enabled": "True",
-                        }
     
     def timeout_milliseconds(self):
         "Return the 'timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.timeout)
+        return _timedelta_to_milliseconds(self.timeout)
     
     def extended_timeout_milliseconds(self):
         "Return the 'extended_timeout' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.extended_timeout)
+        return _timedelta_to_milliseconds(self.extended_timeout)
     
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
-        return timedelta_to_milliseconds(self.interval)
+        return _timedelta_to_milliseconds(self.interval)
     
     def approval_delay_milliseconds(self):
-        return timedelta_to_milliseconds(self.approval_delay)
-
-    @staticmethod
-    def config_parser(config):
-        """ Construct a new dict of client settings of this form:
-        { client_name: {setting_name: value, ...}, ...}
-        with exceptions for any special settings as defined above"""
-        settings = {}
-        for client_name in config.sections():
-            section = dict(config.items(client_name))
-            client = settings[client_name] = {}
-            
-            client["host"] = section["host"]
-            # Reformat values from string types to Python types
-            client["approved_by_default"] = config.getboolean(
-                client_name, "approved_by_default")
-            client["enabled"] = config.getboolean(client_name, "enabled")
-            
-            client["fingerprint"] = (section["fingerprint"].upper()
-                                     .replace(" ", ""))
-            if "secret" in section:
-                client["secret"] = section["secret"].decode("base64")
-            elif "secfile" in section:
-                with open(os.path.expanduser(os.path.expandvars
-                                             (section["secfile"])),
-                          "rb") as secfile:
-                    client["secret"] = secfile.read()
-            else:
-                raise TypeError("No secret or secfile for section %s"
-                                % section)
-            client["timeout"] = string_to_delta(section["timeout"])
-            client["extended_timeout"] = string_to_delta(
-                section["extended_timeout"])
-            client["interval"] = string_to_delta(section["interval"])
-            client["approval_delay"] = string_to_delta(
-                section["approval_delay"])
-            client["approval_duration"] = string_to_delta(
-                section["approval_duration"])
-            client["checker_command"] = section["checker"]
-            client["last_approval_request"] = None
-            client["last_checked_ok"] = None
-            client["last_checker_status"] = None
-            if client["enabled"]:
-                client["last_enabled"] = datetime.datetime.utcnow()
-                client["expires"] = (datetime.datetime.utcnow()
-                                     + client["timeout"])
-            else:
-                client["last_enabled"] = None
-                client["expires"] = None
-
-        return settings
-        
-        
-    def __init__(self, settings, name = None):
+        return _timedelta_to_milliseconds(self.approval_delay)
+    
+    def __init__(self, name = None, config=None):
         """Note: the 'checker' key in 'config' sets the
         'checker_command' attribute and *not* the 'checker'
         attribute."""
         self.name = name
-        # adding all client settings
-        for setting, value in settings.iteritems():
-            setattr(self, setting, value)
-        
+        if config is None:
+            config = {}
         logger.debug("Creating client %r", self.name)
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
+        self.fingerprint = (config["fingerprint"].upper()
+                            .replace(" ", ""))
         logger.debug("  Fingerprint: %s", self.fingerprint)
-        self.created = settings.get("created", datetime.datetime.utcnow())
-
-        # attributes specific for this server instance
+        if "secret" in config:
+            self.secret = config["secret"].decode("base64")
+        elif "secfile" in config:
+            with open(os.path.expanduser(os.path.expandvars
+                                         (config["secfile"])),
+                      "rb") as secfile:
+                self.secret = secfile.read()
+        else:
+            raise TypeError("No secret or secfile for client %s"
+                            % self.name)
+        self.host = config.get("host", "")
+        self.created = datetime.datetime.utcnow()
+        self.enabled = True
+        self.last_approval_request = None
+        self.last_enabled = datetime.datetime.utcnow()
+        self.last_checked_ok = None
+        self.last_checker_status = None
+        self.timeout = string_to_delta(config["timeout"])
+        self.extended_timeout = string_to_delta(config
+                                                ["extended_timeout"])
+        self.interval = string_to_delta(config["interval"])
         self.checker = None
         self.checker_initiator_tag = None
         self.disable_initiator_tag = None
+        self.expires = datetime.datetime.utcnow() + self.timeout
         self.checker_callback_tag = None
+        self.checker_command = config["checker"]
         self.current_checker_command = None
-        self.approved = None
+        self._approved = None
+        self.approved_by_default = config.get("approved_by_default",
+                                              True)
         self.approvals_pending = 0
+        self.approval_delay = string_to_delta(
+            config["approval_delay"])
+        self.approval_duration = string_to_delta(
+            config["approval_duration"])
         self.changedstate = (multiprocessing_manager
                              .Condition(multiprocessing_manager
                                         .Lock()))
@@ -604,7 +569,7 @@
         self.checker_callback_tag = None
         self.checker = None
         if os.WIFEXITED(condition):
-            self.last_checker_status = os.WEXITSTATUS(condition)
+            self.last_checker_status =  os.WEXITSTATUS(condition)
             if self.last_checker_status == 0:
                 logger.info("Checker for %(name)s succeeded",
                             vars(self))
@@ -630,7 +595,7 @@
             gobject.source_remove(self.disable_initiator_tag)
         if getattr(self, "enabled", False):
             self.disable_initiator_tag = (gobject.timeout_add
-                                          (timedelta_to_milliseconds
+                                          (_timedelta_to_milliseconds
                                            (timeout), self.disable))
             self.expires = datetime.datetime.utcnow() + timeout
     
@@ -1040,7 +1005,6 @@
     def __init__(self, bus = None, *args, **kwargs):
         self.bus = bus
         Client.__init__(self, *args, **kwargs)
-        self._approvals_pending = 0
         
         self._approvals_pending = 0
         # Only now, when this client is initialized, can it show up on
@@ -1098,24 +1062,24 @@
         datetime_to_dbus, "LastApprovalRequest")
     approved_by_default = notifychangeproperty(dbus.Boolean,
                                                "ApprovedByDefault")
-    approval_delay = notifychangeproperty(dbus.UInt64,
+    approval_delay = notifychangeproperty(dbus.UInt16,
                                           "ApprovalDelay",
                                           type_func =
-                                          timedelta_to_milliseconds)
+                                          _timedelta_to_milliseconds)
     approval_duration = notifychangeproperty(
-        dbus.UInt64, "ApprovalDuration",
-        type_func = timedelta_to_milliseconds)
+        dbus.UInt16, "ApprovalDuration",
+        type_func = _timedelta_to_milliseconds)
     host = notifychangeproperty(dbus.String, "Host")
-    timeout = notifychangeproperty(dbus.UInt64, "Timeout",
+    timeout = notifychangeproperty(dbus.UInt16, "Timeout",
                                    type_func =
-                                   timedelta_to_milliseconds)
+                                   _timedelta_to_milliseconds)
     extended_timeout = notifychangeproperty(
-        dbus.UInt64, "ExtendedTimeout",
-        type_func = timedelta_to_milliseconds)
-    interval = notifychangeproperty(dbus.UInt64,
+        dbus.UInt16, "ExtendedTimeout",
+        type_func = _timedelta_to_milliseconds)
+    interval = notifychangeproperty(dbus.UInt16,
                                     "Interval",
                                     type_func =
-                                    timedelta_to_milliseconds)
+                                    _timedelta_to_milliseconds)
     checker_command = notifychangeproperty(dbus.String, "Checker")
     
     del notifychangeproperty
@@ -1163,13 +1127,13 @@
         return r
     
     def _reset_approved(self):
-        self.approved = None
+        self._approved = None
         return False
     
     def approve(self, value=True):
         self.send_changedstate()
-        self.approved = value
-        gobject.timeout_add(timedelta_to_milliseconds
+        self._approved = value
+        gobject.timeout_add(_timedelta_to_milliseconds
                             (self.approval_duration),
                             self._reset_approved)
     
@@ -1289,7 +1253,7 @@
                            access="readwrite")
     def ApprovalDuration_dbus_property(self, value=None):
         if value is None:       # get
-            return dbus.UInt64(timedelta_to_milliseconds(
+            return dbus.UInt64(_timedelta_to_milliseconds(
                     self.approval_duration))
         self.approval_duration = datetime.timedelta(0, 0, 0, value)
     
@@ -1309,12 +1273,12 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = unicode(value)
+        self.host = value
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
     def Created_dbus_property(self):
-        return datetime_to_dbus(self.created)
+        return dbus.String(datetime_to_dbus(self.created))
     
     # LastEnabled - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1364,11 +1328,11 @@
         gobject.source_remove(self.disable_initiator_tag)
         self.disable_initiator_tag = None
         self.expires = None
-        time_to_die = timedelta_to_milliseconds((self
-                                                 .last_checked_ok
-                                                 + self.timeout)
-                                                - datetime.datetime
-                                                .utcnow())
+        time_to_die = _timedelta_to_milliseconds((self
+                                                  .last_checked_ok
+                                                  + self.timeout)
+                                                 - datetime.datetime
+                                                 .utcnow())
         if time_to_die <= 0:
             # The timeout has passed
             self.disable()
@@ -1396,12 +1360,11 @@
         self.interval = datetime.timedelta(0, 0, 0, value)
         if getattr(self, "checker_initiator_tag", None) is None:
             return
-        if self.enabled:
-            # Reschedule checker run
-            gobject.source_remove(self.checker_initiator_tag)
-            self.checker_initiator_tag = (gobject.timeout_add
-                                          (value, self.start_checker))
-            self.start_checker()    # Start one now, too
+        # Reschedule checker run
+        gobject.source_remove(self.checker_initiator_tag)
+        self.checker_initiator_tag = (gobject.timeout_add
+                                      (value, self.start_checker))
+        self.start_checker()    # Start one now, too
     
     # Checker - property
     @dbus_service_property(_interface, signature="s",
@@ -1409,7 +1372,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = unicode(value)
+        self.checker_command = value
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1444,7 +1407,7 @@
             raise KeyError()
     
     def __getattribute__(self, name):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__getattribute__(name)
         self._pipe.send(('getattr', name))
         data = self._pipe.recv()
@@ -1457,7 +1420,7 @@
             return func
     
     def __setattr__(self, name, value):
-        if name == '_pipe':
+        if(name == '_pipe'):
             return super(ProxyClient, self).__setattr__(name, value)
         self._pipe.send(('setattr', name, value))
 
@@ -1532,6 +1495,9 @@
                     logger.warning("Bad certificate: %s", error)
                     return
                 logger.debug("Fingerprint: %s", fpr)
+                if self.server.use_dbus:
+                    # Emit D-Bus signal
+                    client.NewRequest(str(self.client_address))
                 
                 try:
                     client = ProxyClient(child_pipe, fpr,
@@ -1539,10 +1505,6 @@
                 except KeyError:
                     return
                 
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.NewRequest(str(self.client_address))
-                
                 if client.approval_delay:
                     delay = client.approval_delay
                     client.approvals_pending += 1
@@ -1557,10 +1519,10 @@
                             client.Rejected("Disabled")
                         return
                     
-                    if client.approved or not client.approval_delay:
+                    if client._approved or not client.approval_delay:
                         #We are approved or approval is disabled
                         break
-                    elif client.approved is None:
+                    elif client._approved is None:
                         logger.info("Client %s needs approval",
                                     client.name)
                         if self.server.use_dbus:
@@ -1580,7 +1542,7 @@
                     time = datetime.datetime.now()
                     client.changedstate.acquire()
                     (client.changedstate.wait
-                     (float(client.timedelta_to_milliseconds(delay)
+                     (float(client._timedelta_to_milliseconds(delay)
                             / 1000)))
                     client.changedstate.release()
                     time2 = datetime.datetime.now()
@@ -1694,7 +1656,7 @@
     def sub_process_main(self, request, address):
         try:
             self.finish_request(request, address)
-        except Exception:
+        except:
             self.handle_error(request, address)
         self.close_request(request)
     
@@ -2079,13 +2041,13 @@
                                      stored_state_file)
     
     if debug:
-        initlogger(debug, logging.DEBUG)
+        initlogger(logging.DEBUG)
     else:
         if not debuglevel:
-            initlogger(debug)
+            initlogger()
         else:
             level = getattr(logging, debuglevel.upper())
-            initlogger(debug, level)
+            initlogger(level)
     
     if server_settings["servicename"] != "Mandos":
         syslogger.setFormatter(logging.Formatter
@@ -2094,7 +2056,15 @@
                                 % server_settings["servicename"]))
     
     # Parse config file with clients
-    client_config = configparser.SafeConfigParser(Client.client_defaults)
+    client_defaults = { "timeout": "5m",
+                        "extended_timeout": "15m",
+                        "interval": "2m",
+                        "checker": "fping -q -- %%(host)s",
+                        "host": "",
+                        "approval_delay": "0s",
+                        "approval_duration": "1s",
+                        }
+    client_config = configparser.SafeConfigParser(client_defaults)
     client_config.read(os.path.join(server_settings["configdir"],
                                     "clients.conf"))
     
@@ -2157,14 +2127,15 @@
         os.dup2(null, sys.stdin.fileno())
         if null > 2:
             os.close(null)
+    else:
+        # No console logging
+        logger.removeHandler(console)
     
     # Need to fork before connecting to D-Bus
     if not debug:
         # Close all input and output, do double fork, etc.
         daemon()
     
-    gobject.threads_init()
-    
     global main_loop
     # From the Avahi example code
     DBusGMainLoop(set_as_default=True )
@@ -2200,9 +2171,28 @@
         client_class = functools.partial(ClientDBusTransitional,
                                          bus = bus)
     
-    client_settings = Client.config_parser(client_config)
+    special_settings = {
+        # Some settings need to be accessd by special methods;
+        # booleans need .getboolean(), etc.  Here is a list of them:
+        "approved_by_default":
+            lambda section:
+            client_config.getboolean(section, "approved_by_default"),
+        }
+    # Construct a new dict of client settings of this form:
+    # { client_name: {setting_name: value, ...}, ...}
+    # with exceptions for any special settings as defined above
+    client_settings = dict((clientname,
+                           dict((setting,
+                                 (value
+                                  if setting not in special_settings
+                                  else special_settings[setting]
+                                  (clientname)))
+                                for setting, value in
+                                client_config.items(clientname)))
+                          for clientname in client_config.sections())
+    
     old_client_settings = {}
-    clients_data = {}
+    clients_data = []
     
     # Get client data and settings from last running state.
     if server_settings["restore"]:
@@ -2216,12 +2206,11 @@
                            .format(e))
             if e.errno != errno.ENOENT:
                 raise
-        except EOFError as e:
-            logger.warning("Could not load persistent state: "
-                           "EOFError: {0}".format(e))
     
-    with PGPEngine() as pgp:
-        for client_name, client in clients_data.iteritems():
+    with Crypto() as crypt:
+        for client in clients_data:
+            client_name = client["name"]
+            
             # Decide which value to use after restoring saved state.
             # We have three different values: Old config file,
             # new config file, and saved state.
@@ -2235,57 +2224,73 @@
                     if (name != "secret" and
                         value != old_client_settings[client_name]
                         [name]):
-                        client[name] = value
+                        setattr(client, name, value)
                 except KeyError:
                     pass
             
             # Clients who has passed its expire date can still be
-            # enabled if its last checker was successful.  Clients
+            # enabled if its last checker was sucessful.  Clients
             # whose checker failed before we stored its state is
             # assumed to have failed all checkers during downtime.
-            if client["enabled"]:
-                if datetime.datetime.utcnow() >= client["expires"]:
-                    if not client["last_checked_ok"]:
-                        logger.warning(
-                            "disabling client {0} - Client never "
-                            "performed a successfull checker"
-                            .format(client["name"]))
-                        client["enabled"] = False
-                    elif client["last_checker_status"] != 0:
-                        logger.warning(
-                            "disabling client {0} - Client "
-                            "last checker failed with error code {1}"
-                            .format(client["name"],
-                                    client["last_checker_status"]))
+            if client["enabled"] and client["last_checked_ok"]:
+                if ((datetime.datetime.utcnow()
+                     - client["last_checked_ok"])
+                    > client["interval"]):
+                    if client["last_checker_status"] != 0:
                         client["enabled"] = False
                     else:
                         client["expires"] = (datetime.datetime
                                              .utcnow()
                                              + client["timeout"])
-                    
+            
+            client["changedstate"] = (multiprocessing_manager
+                                      .Condition
+                                      (multiprocessing_manager
+                                       .Lock()))
+            if use_dbus:
+                new_client = (ClientDBusTransitional.__new__
+                              (ClientDBusTransitional))
+                tcp_server.clients[client_name] = new_client
+                new_client.bus = bus
+                for name, value in client.iteritems():
+                    setattr(new_client, name, value)
+                client_object_name = unicode(client_name).translate(
+                    {ord("."): ord("_"),
+                     ord("-"): ord("_")})
+                new_client.dbus_object_path = (dbus.ObjectPath
+                                               ("/clients/"
+                                                + client_object_name))
+                DBusObjectWithProperties.__init__(new_client,
+                                                  new_client.bus,
+                                                  new_client
+                                                  .dbus_object_path)
+            else:
+                tcp_server.clients[client_name] = (Client.__new__
+                                                   (Client))
+                for name, value in client.iteritems():
+                    setattr(tcp_server.clients[client_name],
+                            name, value)
+            
             try:
-                client["secret"] = (
-                    pgp.decrypt(client["encrypted_secret"],
-                                client_settings[client_name]
-                                ["secret"]))
-            except PGPError:
+                tcp_server.clients[client_name].secret = (
+                    crypt.decrypt(tcp_server.clients[client_name]
+                                  .encrypted_secret,
+                                  client_settings[client_name]
+                                  ["secret"]))
+            except CryptoError:
                 # If decryption fails, we use secret from new settings
-                logger.debug("Failed to decrypt {0} old secret"
-                             .format(client_name))
-                client["secret"] = (
+                tcp_server.clients[client_name].secret = (
                     client_settings[client_name]["secret"])
-
     
-    # Add/remove clients based on new changes made to config
-    for client_name in set(old_client_settings) - set(client_settings):
-        del clients_data[client_name]
-    for client_name in set(client_settings) - set(old_client_settings):
-        clients_data[client_name] = client_settings[client_name]
-
-    # Create clients all clients
-    for client_name, client in clients_data.iteritems():
-        tcp_server.clients[client_name] = client_class(
-            name = client_name, settings = client)
+    # Create/remove clients based on new changes made to config
+    for clientname in set(old_client_settings) - set(client_settings):
+        del tcp_server.clients[clientname]
+    for clientname in set(client_settings) - set(old_client_settings):
+        tcp_server.clients[clientname] = (client_class(name
+                                                       = clientname,
+                                                       config =
+                                                       client_settings
+                                                       [clientname]))
     
     if not tcp_server.clients:
         logger.warning("No clients defined")
@@ -2303,6 +2308,7 @@
             # "pidfile" was never created
             pass
         del pidfilename
+        
         signal.signal(signal.SIGINT, signal.SIG_IGN)
     
     signal.signal(signal.SIGHUP, lambda signum, frame: sys.exit())
@@ -2377,18 +2383,17 @@
         # Store client before exiting. Secrets are encrypted with key
         # based on what config file has. If config file is
         # removed/edited, old secret will thus be unrecovable.
-        clients = {}
-        with PGPEngine() as pgp:
+        clients = []
+        with Crypto() as crypt:
             for client in tcp_server.clients.itervalues():
                 key = client_settings[client.name]["secret"]
-                client.encrypted_secret = pgp.encrypt(client.secret,
-                                                      key)
+                client.encrypted_secret = crypt.encrypt(client.secret,
+                                                        key)
                 client_dict = {}
                 
-                # A list of attributes that can not be pickled
-                # + secret.
-                exclude = set(("bus", "changedstate", "secret",
-                               "checker"))
+                # A list of attributes that will not be stored when
+                # shutting down.
+                exclude = set(("bus", "changedstate", "secret"))
                 for name, typ in (inspect.getmembers
                                   (dbus.service.Object)):
                     exclude.add(name)
@@ -2399,28 +2404,19 @@
                     if attr not in exclude:
                         client_dict[attr] = getattr(client, attr)
                 
-                clients[client.name] = client_dict
+                clients.append(client_dict)
                 del client_settings[client.name]["secret"]
         
         try:
-            tempfd, tempname = tempfile.mkstemp(suffix=".pickle",
-                                                prefix="clients-",
-                                                dir=os.path.dirname
-                                                (stored_state_path))
-            with os.fdopen(tempfd, "wb") as stored_state:
+            with os.fdopen(os.open(stored_state_path,
+                                   os.O_CREAT|os.O_WRONLY|os.O_TRUNC,
+                                   0600), "wb") as stored_state:
                 pickle.dump((clients, client_settings), stored_state)
-            os.rename(tempname, stored_state_path)
         except (IOError, OSError) as e:
             logger.warning("Could not save persistent state: {0}"
                            .format(e))
-            if not debug:
-                try:
-                    os.remove(tempname)
-                except NameError:
-                    pass
-            if e.errno not in set((errno.ENOENT, errno.EACCES,
-                                   errno.EEXIST)):
-                raise e
+            if e.errno not in (errno.ENOENT, errno.EACCES):
+                raise
         
         # Delete all clients, and settings from config
         while tcp_server.clients:
@@ -2490,5 +2486,6 @@
     # Must run before the D-Bus bus name gets deregistered
     cleanup()
 
+
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2011-11-26 23:08:17 +0000
+++ mandos-clients.conf.xml	2011-10-10 20:29:58 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2011-11-26">
+<!ENTITY TIMESTAMP "2011-10-10">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -344,20 +344,6 @@
 	</listitem>
       </varlistentry>
       
-      <varlistentry>
-	<term><option>enabled<literal> = </literal>{ <literal
-	>1</literal> | <literal>yes</literal> |	<literal>true</literal
-	> | <literal >on</literal> | <literal>0</literal> | <literal
-	>no</literal> | <literal>false</literal> | <literal
-	>off</literal> }</option></term>
-	<listitem>
-	  <para>
-	    Whether this client should be enabled by default.  The
-	    default is <quote>true</quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
-      
     </variablelist>
   </refsect1>
   

=== modified file 'mandos-ctl'
--- mandos-ctl	2011-12-21 17:17:32 +0000
+++ mandos-ctl	2011-10-15 16:48:03 +0000
@@ -93,23 +93,29 @@
     >>> string_to_delta("5m 30s")
     datetime.timedelta(0, 330)
     """
-    value = datetime.timedelta(0)
-    regexp = re.compile("(\d+)([dsmhw]?)")
+    timevalue = datetime.timedelta(0)
+    regexp = re.compile("\d+[dsmhw]")
     
-    for num, suffix in regexp.findall(interval):
-        if suffix == "d":
-            value += datetime.timedelta(int(num))
-        elif suffix == "s":
-            value += datetime.timedelta(0, int(num))
-        elif suffix == "m":
-            value += datetime.timedelta(0, 0, 0, 0, int(num))
-        elif suffix == "h":
-            value += datetime.timedelta(0, 0, 0, 0, 0, int(num))
-        elif suffix == "w":
-            value += datetime.timedelta(0, 0, 0, 0, 0, 0, int(num))
-        elif suffix == "":
-            value += datetime.timedelta(0, 0, 0, int(num))
-    return value
+    for s in regexp.findall(interval):
+        try:
+            suffix = unicode(s[-1])
+            value = int(s[:-1])
+            if suffix == "d":
+                delta = datetime.timedelta(value)
+            elif suffix == "s":
+                delta = datetime.timedelta(0, value)
+            elif suffix == "m":
+                delta = datetime.timedelta(0, 0, 0, 0, value)
+            elif suffix == "h":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
+            elif suffix == "w":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
+            else:
+                raise ValueError
+        except (ValueError, IndexError):
+            raise ValueError
+        timevalue += delta
+    return timevalue
 
 def print_clients(clients, keywords):
     def valuetostring(value, keyword):
@@ -236,7 +242,7 @@
             #restore stderr
             os.dup2(stderrcopy, sys.stderr.fileno())
             os.close(stderrcopy)
-    except dbus.exceptions.DBusException:
+    except dbus.exceptions.DBusException, e:
         print("Access denied: Accessing mandos server through dbus.",
               file=sys.stderr)
         sys.exit(1)

=== modified file 'mandos-keygen.xml'
--- mandos-keygen.xml	2011-11-12 18:14:55 +0000
+++ mandos-keygen.xml	2011-10-05 16:00:56 +0000
@@ -214,7 +214,7 @@
 	<listitem>
 	  <para>
 	    Target directory for key files.  Default is
-	    <filename class="directory">/etc/mandos</filename>.
+	    <filename>/etc/mandos</filename>.
 	  </para>
 	</listitem>
       </varlistentry>
@@ -411,7 +411,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/tmp</filename></term>
+	<term><filename>/tmp</filename></term>
 	<listitem>
 	  <para>
 	    Temporary files will be written here if
@@ -452,9 +452,9 @@
     </informalexample>
     <informalexample>
       <para>
-	Prompt for a password, encrypt it with the key in <filename
-	class="directory">/etc/mandos</filename> and output a section
-	suitable for <filename>clients.conf</filename>.
+	Prompt for a password, encrypt it with the key in
+	<filename>/etc/mandos</filename> and output a section suitable
+	for <filename>clients.conf</filename>.
       </para>
       <para>
 	<userinput>&COMMANDNAME; --password</userinput>

=== modified file 'mandos.xml'
--- mandos.xml	2011-12-21 00:29:33 +0000
+++ mandos.xml	2011-11-26 22:22:20 +0000
@@ -407,7 +407,7 @@
     <title>LOGGING</title>
     <para>
       The server will send log message with various severity levels to
-      <filename class="devicefile">/dev/log</filename>.  With the
+      <filename>/dev/log</filename>.  With the
       <option>--debug</option> option, it will log even more messages,
       and also show them on the console.
     </para>
@@ -489,9 +489,6 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="devicefile">/dev/log</filename></term>
-      </varlistentry>
-      <varlistentry>
 	<term><filename
 	class="directory">/var/lib/mandos</filename></term>
 	<listitem>

=== removed directory 'network-hooks.d'
=== removed file 'network-hooks.d/bridge'
--- network-hooks.d/bridge	2011-12-27 03:56:39 +0000
+++ network-hooks.d/bridge	1970-01-01 00:00:00 +0000
@@ -1,74 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up a bridge interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-CONFIG="$MANDOSNETHOOKDIR/bridge.conf"
-
-# Read config file, which must set "BRIDGE", "PORTS", and optionally
-# "IPADDRS" and "ROUTES".
-if [ -e "$CONFIG" ]; then
-    . "$CONFIG"
-fi
-
-if [ -z "$BRIDGE" -o -z "$PORTS" ]; then
-    exit
-fi
-
-if [ -n "$DEVICE" -a "$DEVICE" != "$BRIDGE" ]; then
-    exit
-fi
-
-for b in /sbin/brctl /usr/sbin/brctl; do
-    if [ -e "$b" ]; then
-	brctl="$b"
-	break
-    fi
-done
-
-case "$1" in
-    start)
-	"$brctl" addbr "$BRIDGE"
-	for port in $PORTS; do
-	    "$brctl" addif "$BRIDGE" "$port"
-	    ip link set dev "$port" up
-	done
-	ip link set dev "$BRIDGE" up
-	sleep "$DELAY"
-	if [ -n "$IPADDRS" ]; then
-            for ipaddr in $IPADDRS; do
-		ip addr add "$ipaddr" dev "$BRIDGE"
-	    done
-	fi
-	if [ -n "$ROUTES" ]; then
-            for route in $ROUTES; do
-		ip route add "$route" dev "$BRIDGE"
-	    done
-	fi
-	;;
-    stop)
-	ip link set dev "$BRIDGE" down
-	for port in $PORTS; do
-	    ip link set dev "$port" down
-	    "$brctl" delif "$BRIDGE" "$port"
-	done
-	"$brctl" delbr "$BRIDGE"
-	;;
-    files)
-	echo /bin/ip
-	echo "$brctl"
-	;;
-    modules)
-	echo bridge
-	;;
-esac

=== removed file 'network-hooks.d/bridge.conf'
--- network-hooks.d/bridge.conf	2011-11-24 20:15:24 +0000
+++ network-hooks.d/bridge.conf	1970-01-01 00:00:00 +0000
@@ -1,11 +0,0 @@
-## Required
-
-#BRIDGE=br0
-
-#PORTS="eth0 eth1"
-
-## Optional
-
-#IPADDRS="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
-
-#ROUTES="192.0.2.0/24 2001:DB8::/32"

=== removed file 'network-hooks.d/openvpn'
--- network-hooks.d/openvpn	2011-12-02 16:52:50 +0000
+++ network-hooks.d/openvpn	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up an OpenVPN interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-CONFIG="openvpn.conf"
-
-# Extract the "dev" setting from the config file
-VPNDEVICE="`sed -n -e 's/#.*//' -e 's/^[[:space:]]*dev[[:space:]]\+//p' \"$MANDOSNETHOOKDIR/$CONFIG\"`"
-
-PIDFILE=/run/openvpn-mandos.pid
-
-# Exit if no device set in config
-if [ -z "$VPNDEVICE" ]; then
-    exit
-fi
-
-# Exit if DEVICE is set and it doesn't match the VPN interface
-if [ -n "$DEVICE" -a "$DEVICE" = "${DEVICE#$VPNDEVICE}" ]; then
-    exit
-fi
-
-openvpn=/usr/sbin/openvpn
-
-case "$1" in
-    start)
-	"$openvpn" --cd "$MANDOSNETHOOKDIR" --daemon 'openvpn(Mandos)' --writepid "$PIDFILE" --config "$CONFIG"
-	sleep "$DELAY"
-	;;
-    stop)
-	PID="`cat \"$PIDFILE\"`"
-	if [ "$PID" -gt 0 ]; then
-	    kill "$PID"
-	fi
-	;;
-    files)
-	echo "$openvpn"
-	;;
-    modules)
-	echo tun
-	;;
-esac

=== removed file 'network-hooks.d/openvpn.conf'
--- network-hooks.d/openvpn.conf	2011-12-02 16:52:50 +0000
+++ network-hooks.d/openvpn.conf	1970-01-01 00:00:00 +0000
@@ -1,19 +0,0 @@
-# Sample OpenVPN configuration file
-# Uncomment and change - see openvpn(8)
-
-# Network device.
-#dev tun
-
-# Our remote peer
-#remote 192.0.2.3
-#float 192.0.2.3
-#port 1194
-
-# VPN endpoints
-#ifconfig 10.1.0.1 10.1.0.2
-
-# A pre-shared static key
-#secret openvpn.key
-
-# Cipher
-#cipher AES-128-CBC

=== removed file 'network-hooks.d/wireless'
--- network-hooks.d/wireless	2011-12-27 03:56:39 +0000
+++ network-hooks.d/wireless	1970-01-01 00:00:00 +0000
@@ -1,136 +0,0 @@
-#!/bin/sh
-#
-# This is an example of a Mandos client network hook.  This hook
-# brings up a wireless interface as specified in a separate
-# configuration file.  To be used, this file and any needed
-# configuration file(s) should be copied into the
-# /etc/mandos/network-hooks.d directory.
-# 
-# Copying and distribution of this file, with or without modification,
-# are permitted in any medium without royalty provided the copyright
-# notice and this notice are preserved.  This file is offered as-is,
-# without any warranty.
-
-set -e
-
-RUNDIR="/run"
-CTRL="$RUNDIR/wpa_supplicant-global"
-CTRLDIR="$RUNDIR/wpa_supplicant"
-PIDFILE="$RUNDIR/wpa_supplicant-mandos.pid"
-
-CONFIG="$MANDOSNETHOOKDIR/wireless.conf"
-
-# Read config file
-if [ -e "$CONFIG" ]; then
-    . "$CONFIG"
-else
-    exit
-fi
-
-interfaces="`env|sed -n -e 's/^\(MODULE\|IPADDRS\|ROUTES\|WPA_DRIVER\)_\([^=]*\)=.*/\2/p' \"$CONFIG\" |sort -u`"
-
-# Exit if DEVICE is set and is not any of the wireless interfaces
-if [ -n "$DEVICE" ]; then
-    while :; do
-	for IF in $interfaces; do
-	    if [ "$IF" = "$DEVICE" ]; then
-		break 2
-	    fi
-	done
-	exit
-    done
-fi
-
-wpa_supplicant=/sbin/wpa_supplicant
-wpa_cli=/sbin/wpa_cli
-ip=/bin/ip
-
-# Used by the wpa_interface_* functions in the wireless.conf file
-wpa_cli_set(){
-    case "$1" in
-        ssid|psk) arg="\"$2\"" ;;
-        *) arg="$2" ;;
-    esac
-    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" \
-	"$1" "$arg" 2>&1 | sed -e '/^OK$/d'
-}
-
-if [ $VERBOSITY -gt 0 ]; then
-    WPAS_OPTIONS="-d $WPAS_OPTIONS"
-fi
-if [ -n "$PIDFILE" ]; then
-    WPAS_OPTIONS="-P$PIDFILE $WPAS_OPTIONS"
-fi
-
-case "${MODE:-$1}" in
-    start)
-	mkdir -m u=rwx,go= -p "$CTRLDIR"
-	"$wpa_supplicant" -B -g "$CTRL" -p "$CTRLDIR" $WPAS_OPTIONS
-        for INTERFACE in $interfaces; do
-	    DRIVER=`eval 'echo "$WPA_DRIVER_'"$INTERFACE"\"`
-	    DELAY=`eval 'echo "$DELAY_'"$INTERFACE"\"`
-	    "$wpa_cli" -g "$CTRL" interface_add "$INTERFACE" "" \
-		"${DRIVER:-wext}" "$CTRLDIR" > /dev/null \
-		| sed -e '/^OK$/d'
-	    NETWORK=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" add_network`
-	    eval wpa_interface_"$INTERFACE"
-	    "$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" enable_network \
-		"$NETWORK" | sed -e '/^OK$/d'
-	    ( sleep "${DELAY:-$DELAY}" || : ) &
-	    sleep=$!
-	    while :; do
-		kill -0 $sleep || break
-		STATE=`"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" status | sed -n -e 's/^wpa_state=//p'`
-		if [ "$STATE" = COMPLETED ]; then
-		    kill $sleep
-		    break
-		fi
-		sleep 1
-	    done &
-	    wait $sleep || :
-	    IPADDRS=`eval 'echo "$IPADDRS_'"$INTERFACE"\"`
-	    if [ -n "$IPADDRS" ]; then
-		if [ "$IPADDRS" = dhcp ]; then
-		    ipconfig -c dhcp -d "$INTERFACE" || :
-		    #dhclient "$INTERFACE"
-		else
-		    for ipaddr in $IPADDRS; do
-			"$ip" addr add "$ipaddr" dev "$INTERFACE"
-		    done
-		fi
-	    fi
-	    ROUTES=`eval 'echo "$ROUTES_'"$INTERFACE"\"`
-	    if [ -n "$ROUTES" ]; then
-		for route in $ROUTES; do
-		    "$ip" route add "$route" dev "$BRIDGE"
-		done
-	    fi
-        done
-	;;
-    stop)
-	"$wpa_cli" -g "$CTRL" terminate 2>&1 | sed -e '/^OK$/d'
-        for INTERFACE in $interfaces; do
-	    "$ip" addr show scope global permanent dev "$INTERFACE" \
-		| while read type addr rest; do
-		case "$type" in
-		    inet|inet6)
-			"$ip" addr del "$addr" dev "$INTERFACE"
-			;;
-		esac
-	    done
-	    "$ip" link set dev "$INTERFACE" down
-	done
-	;;
-    files)
-	echo "$wpa_supplicant"
-	echo "$wpa_cli"
-	echo "$ip"
-	;;
-    modules)
-	if [ "$IPADDRS" = dhcp ]; then
-	    echo af_packet
-	fi
-	sed -n -e 's/#.*$//' -e 's/[ 	]*$//' -e 's/^MODULE=//p' \
-	    "$CONFIG"
-	;;
-esac

=== removed file 'network-hooks.d/wireless.conf'
--- network-hooks.d/wireless.conf	2011-12-27 03:56:39 +0000
+++ network-hooks.d/wireless.conf	1970-01-01 00:00:00 +0000
@@ -1,17 +0,0 @@
-# Extra options for wpa_supplicant, if any
-#WPAS_OPTIONS=""
-
-# wlan0
-MODULE_wlan0=ath9k
-#WPA_DRIVER_wlan0=wext
-wpa_interface_wlan0(){
-    # Use this format to set simple things:
-    wpa_cli_set ssid home
-    wpa_cli_set psk "secret passphrase"
-    # Use this format to do more complex things with wpa_cli:
-    #"$wpa_cli" -p "$CTRLDIR" -i "$INTERFACE" set_network "$NETWORK" passphrase '"secret passphrase"'
-}
-#DELAY_wlan0=10
-IPADDRS_wlan0=dhcp
-#IPADDRS_wlan0="192.0.2.3/24 2001:DB8::aede:48ff:fe71:f6f2/32"
-#ROUTES_wlan0="192.0.2.0/24 2001:DB8::/32"

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2011-12-25 00:40:09 +0000
+++ plugin-runner.c	2011-10-09 12:32:13 +0000
@@ -171,7 +171,6 @@
 }
 
 /* Helper function for add_argument and add_environment */
-__attribute__((nonnull))
 static bool add_to_char_array(const char *new, char ***array,
 			      int *len){
   /* Resize the pointed-to array to hold one more pointer */
@@ -200,7 +199,6 @@
 }
 
 /* Add to a plugin's argument vector */
-__attribute__((nonnull(2)))
 static bool add_argument(plugin *p, const char *arg){
   if(p == NULL){
     return false;
@@ -209,7 +207,6 @@
 }
 
 /* Add to a plugin's environment */
-__attribute__((nonnull(2)))
 static bool add_environment(plugin *p, const char *def, bool replace){
   if(p == NULL){
     return false;
@@ -289,7 +286,6 @@
 }
 
 /* Prints out a password to stdout */
-__attribute__((nonnull))
 static bool print_out_password(const char *buffer, size_t length){
   ssize_t ret;
   for(size_t written = 0; written < length; written += (size_t)ret){
@@ -303,7 +299,6 @@
 }
 
 /* Removes and free a plugin from the plugin list */
-__attribute__((nonnull))
 static void free_plugin(plugin *plugin_node){
   
   for(char **arg = plugin_node->argv; *arg != NULL; arg++){
@@ -421,7 +416,6 @@
     { .name = NULL }
   };
   
-  __attribute__((nonnull(3)))
   error_t parse_opt(int key, char *arg, struct argp_state *state){
     errno = 0;
     switch(key){
@@ -748,7 +742,7 @@
     }
   }
   
-  if(getuid() == 0){
+  {
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
     int plugindir_fd = open(/* plugindir or */ PDIR, O_RDONLY);

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2011-12-24 23:17:02 +0000
+++ plugins.d/askpass-fifo.c	2011-10-05 16:00:56 +0000
@@ -46,7 +46,6 @@
 
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-12-27 03:56:39 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -53,7 +53,7 @@
 				   sockaddr_in6, PF_INET6,
 				   SOCK_STREAM, uid_t, gid_t, open(),
 				   opendir(), DIR */
-#include <sys/stat.h>		/* open(), S_ISREG */
+#include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
 				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
@@ -73,7 +73,7 @@
 				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), seteuid(),
-				   setgid(), pause(), _exit() */
+				   setgid(), pause() */
 #include <arpa/inet.h>		/* inet_pton(), htons, inet_ntop() */
 #include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
@@ -85,9 +85,6 @@
 				   raise() */
 #include <sysexits.h>		/* EX_OSERR, EX_USAGE, EX_UNAVAILABLE,
 				   EX_NOHOST, EX_IOERR, EX_PROTOCOL */
-#include <sys/wait.h>		/* waitpid(), WIFEXITED(),
-				   WEXITSTATUS(), WTERMSIG() */
-#include <grp.h>		/* setgroups() */
 
 #ifdef __linux__
 #include <sys/klog.h> 		/* klogctl() */
@@ -111,8 +108,8 @@
 				   init_gnutls_session(),
 				   GNUTLS_* */
 #include <gnutls/openpgp.h>
-			 /* gnutls_certificate_set_openpgp_key_file(),
-			    GNUTLS_OPENPGP_FMT_BASE64 */
+			  /* gnutls_certificate_set_openpgp_key_file(),
+				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
 #include <gpgme.h> 		/* All GPGME types, constants and
@@ -126,7 +123,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
@@ -134,7 +130,6 @@
 const char *argp_program_bug_address = "<mandos@recompile.se>";
 static const char sys_class_net[] = "/sys/class/net";
 char *connect_to = NULL;
-const char *hookdir = HOOKDIR;
 
 /* Doubly linked list that need to be circularly linked when used */
 typedef struct server{
@@ -170,30 +165,18 @@
 
 /* Function to use when printing errors */
 void perror_plus(const char *print_text){
-  int e = errno;
   fprintf(stderr, "Mandos plugin %s: ",
 	  program_invocation_short_name);
-  errno = e;
   perror(print_text);
 }
 
-__attribute__((format (gnu_printf, 2, 3)))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /*
  * Make additional room in "buffer" for at least BUFFER_SIZE more
  * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
 size_t incbuffer(char **buffer, size_t buffer_length,
-		 size_t buffer_capacity){
+		  size_t buffer_capacity){
   if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
     if(buffer == NULL){
@@ -205,21 +188,22 @@
 }
 
 /* Add server to set of servers to retry periodically */
-bool add_server(const char *ip, uint16_t port, AvahiIfIndex if_index,
-		int af){
+int add_server(const char *ip, uint16_t port,
+		 AvahiIfIndex if_index,
+		 int af){
   int ret;
   server *new_server = malloc(sizeof(server));
   if(new_server == NULL){
     perror_plus("malloc");
-    return false;
+    return -1;
   }
   *new_server = (server){ .ip = strdup(ip),
-			  .port = port,
-			  .if_index = if_index,
-			  .af = af };
+			 .port = port,
+			 .if_index = if_index,
+			 .af = af };
   if(new_server->ip == NULL){
     perror_plus("strdup");
-    return false;
+    return -1;
   }
   /* Special case of first server */
   if (mc.current_server == NULL){
@@ -236,16 +220,16 @@
   ret = clock_gettime(CLOCK_MONOTONIC, &mc.current_server->last_seen);
   if(ret == -1){
     perror_plus("clock_gettime");
-    return false;
+    return -1;
   }
-  return true;
+  return 0;
 }
 
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(const char *seckey, const char *pubkey,
-		       const char *tempdir){
+static bool init_gpgme(const char *seckey,
+		       const char *pubkey, const char *tempdir){
   gpgme_error_t rc;
   gpgme_engine_info_t engine_info;
   
@@ -266,15 +250,15 @@
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
     rc = gpgme_op_import(mc.ctx, pgp_data);
     if(rc != GPG_ERR_NO_ERROR){
-      fprintf_plus(stderr, "bad gpgme_op_import: %s: %s\n",
-		   gpgme_strsource(rc), gpgme_strerror(rc));
+      fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
+	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
@@ -287,23 +271,23 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GPGME\n");
+    fprintf(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_engine_check_version: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
   /* Set GPGME home directory for the OpenPGP engine only */
   rc = gpgme_get_engine_info(&engine_info);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_get_engine_info: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   while(engine_info != NULL){
@@ -315,17 +299,15 @@
     engine_info = engine_info->next;
   }
   if(engine_info == NULL){
-    fprintf_plus(stderr, "Could not set GPGME home dir to %s\n",
-		 tempdir);
+    fprintf(stderr, "Could not set GPGME home dir to %s\n", tempdir);
     return false;
   }
   
   /* Create new GPGME "context" */
   rc = gpgme_new(&(mc.ctx));
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_new: %s: %s\n", gpgme_strsource(rc),
-		 gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
@@ -350,24 +332,23 @@
   ssize_t plaintext_length = 0;
   
   if(debug){
-    fprintf_plus(stderr, "Trying to decrypt OpenPGP data\n");
+    fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "Mandos plugin mandos-client: "
-		 "bad gpgme_data_new: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
     return -1;
   }
@@ -376,32 +357,31 @@
      data buffer */
   rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
   if(rc != GPG_ERR_NO_ERROR){
-    fprintf_plus(stderr, "bad gpgme_op_decrypt: %s: %s\n",
-		 gpgme_strsource(rc), gpgme_strerror(rc));
+    fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
+	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
     if(debug){
       gpgme_decrypt_result_t result;
       result = gpgme_op_decrypt_result(mc.ctx);
       if(result == NULL){
-	fprintf_plus(stderr, "gpgme_op_decrypt_result failed\n");
+	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
-	fprintf_plus(stderr, "Unsupported algorithm: %s\n",
-		     result->unsupported_algorithm);
-	fprintf_plus(stderr, "Wrong key usage: %u\n",
-		     result->wrong_key_usage);
+	fprintf(stderr, "Unsupported algorithm: %s\n",
+		result->unsupported_algorithm);
+	fprintf(stderr, "Wrong key usage: %u\n",
+		result->wrong_key_usage);
 	if(result->file_name != NULL){
-	  fprintf_plus(stderr, "File name: %s\n", result->file_name);
+	  fprintf(stderr, "File name: %s\n", result->file_name);
 	}
 	gpgme_recipient_t recipient;
 	recipient = result->recipients;
 	while(recipient != NULL){
-	  fprintf_plus(stderr, "Public key algorithm: %s\n",
-		       gpgme_pubkey_algo_name
-		       (recipient->pubkey_algo));
-	  fprintf_plus(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf_plus(stderr, "Secret key available: %s\n",
-		       recipient->status == GPG_ERR_NO_SECKEY
-		       ? "No" : "Yes");
+	  fprintf(stderr, "Public key algorithm: %s\n",
+		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
+	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
+	  fprintf(stderr, "Secret key available: %s\n",
+		  recipient->status == GPG_ERR_NO_SECKEY
+		  ? "No" : "Yes");
 	  recipient = recipient->next;
 	}
       }
@@ -410,7 +390,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decryption of OpenPGP data succeeded\n");
+    fprintf(stderr, "Decryption of OpenPGP data succeeded\n");
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
@@ -423,12 +403,12 @@
   *plaintext = NULL;
   while(true){
     plaintext_capacity = incbuffer(plaintext,
-				   (size_t)plaintext_length,
-				   plaintext_capacity);
+				      (size_t)plaintext_length,
+				      plaintext_capacity);
     if(plaintext_capacity == 0){
-      perror_plus("incbuffer");
-      plaintext_length = -1;
-      goto decrypt_end;
+	perror_plus("incbuffer");
+	plaintext_length = -1;
+	goto decrypt_end;
     }
     
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
@@ -447,7 +427,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Decrypted password is: ");
+    fprintf(stderr, "Decrypted password is: ");
     for(ssize_t i = 0; i < plaintext_length; i++){
       fprintf(stderr, "%02hhX ", (*plaintext)[i]);
     }
@@ -475,7 +455,7 @@
 /* GnuTLS log function callback */
 static void debuggnutls(__attribute__((unused)) int level,
 			const char* string){
-  fprintf_plus(stderr, "GnuTLS: %s", string);
+  fprintf(stderr, "GnuTLS: %s", string);
 }
 
 static int init_gnutls_global(const char *pubkeyfilename,
@@ -483,13 +463,13 @@
   int ret;
   
   if(debug){
-    fprintf_plus(stderr, "Initializing GnuTLS\n");
+    fprintf(stderr, "Initializing GnuTLS\n");
   }
   
   ret = gnutls_global_init();
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS global_init: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS global_init: %s\n",
+	    safer_gnutls_strerror(ret));
     return -1;
   }
   
@@ -504,43 +484,41 @@
   /* OpenPGP credentials */
   ret = gnutls_certificate_allocate_credentials(&mc.cred);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "GnuTLS memory error: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "GnuTLS memory error: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_global_deinit();
     return -1;
   }
   
   if(debug){
-    fprintf_plus(stderr, "Attempting to use OpenPGP public key %s and"
-		 " secret key %s as GnuTLS credentials\n",
-		 pubkeyfilename,
-		 seckeyfilename);
+    fprintf(stderr, "Attempting to use OpenPGP public key %s and"
+	    " secret key %s as GnuTLS credentials\n", pubkeyfilename,
+	    seckeyfilename);
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
     (mc.cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error[%d] while reading the OpenPGP key pair ('%s',"
-		 " '%s')\n", ret, pubkeyfilename, seckeyfilename);
-    fprintf_plus(stderr, "The GnuTLS error is: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr,
+	    "Error[%d] while reading the OpenPGP key pair ('%s',"
+	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
+    fprintf(stderr, "The GnuTLS error is: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
   /* GnuTLS server initialization */
   ret = gnutls_dh_params_init(&mc.dh_params);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS DH parameter"
-		 " initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
+	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
   ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error in GnuTLS prime generation: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
@@ -566,9 +544,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr,
-		 "Error in GnuTLS session initialization: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
+	    safer_gnutls_strerror(ret));
   }
   
   {
@@ -581,9 +558,9 @@
       }
     } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
     if(ret != GNUTLS_E_SUCCESS){
-      fprintf_plus(stderr, "Syntax error at: %s\n", err);
-      fprintf_plus(stderr, "GnuTLS error: %s\n",
-		   safer_gnutls_strerror(ret));
+      fprintf(stderr, "Syntax error at: %s\n", err);
+      fprintf(stderr, "GnuTLS error: %s\n",
+	      safer_gnutls_strerror(ret));
       gnutls_deinit(*session);
       return -1;
     }
@@ -598,8 +575,8 @@
     }
   } while(ret == GNUTLS_E_INTERRUPTED or ret == GNUTLS_E_AGAIN);
   if(ret != GNUTLS_E_SUCCESS){
-    fprintf_plus(stderr, "Error setting GnuTLS credentials: %s\n",
-		 safer_gnutls_strerror(ret));
+    fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
+	    safer_gnutls_strerror(ret));
     gnutls_deinit(*session);
     return -1;
   }
@@ -650,7 +627,7 @@
     pf = PF_INET;
     break;
   default:
-    fprintf_plus(stderr, "Bad address family: %d\n", af);
+    fprintf(stderr, "Bad address family: %d\n", af);
     errno = EINVAL;
     return -1;
   }
@@ -661,8 +638,8 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Setting up a TCP connection to %s, port %"
-		 PRIu16 "\n", ip, port);
+    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
+	    "\n", ip, port);
   }
   
   tcp_sd = socket(pf, SOCK_STREAM, 0);
@@ -694,7 +671,7 @@
   }
   if(ret == 0){
     int e = errno;
-    fprintf_plus(stderr, "Bad address: %s\n", ip);
+    fprintf(stderr, "Bad address: %s\n", ip);
     errno = e;
     goto mandos_end;
   }
@@ -705,10 +682,10 @@
     
     if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
        (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
-				-Wunreachable-code*/
+			      -Wunreachable-code*/
       if(if_index == AVAHI_IF_UNSPEC){
-	fprintf_plus(stderr, "An IPv6 link-local address is"
-		     " incomplete without a network interface\n");
+	fprintf(stderr, "An IPv6 link-local address is incomplete"
+		" without a network interface\n");
 	errno = EINVAL;
 	goto mandos_end;
       }
@@ -732,12 +709,12 @@
       if(if_indextoname((unsigned int)if_index, interface) == NULL){
 	perror_plus("if_indextoname");
       } else {
-	fprintf_plus(stderr, "Connection to: %s%%%s, port %" PRIu16
-		     "\n", ip, interface, port);
+	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
+		ip, interface, port);
       }
     } else {
-      fprintf_plus(stderr, "Connection to: %s, port %" PRIu16 "\n",
-		   ip, port);
+      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
+	      port);
     }
     char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
 		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
@@ -753,7 +730,7 @@
       perror_plus("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
-	fprintf_plus(stderr, "Canonical address form: %s\n", addrstr);
+	fprintf(stderr, "Canonical address form: %s\n", addrstr);
       }
     }
   }
@@ -787,7 +764,7 @@
   while(true){
     size_t out_size = strlen(out);
     ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
-					out_size - written));
+				   out_size - written));
     if(ret == -1){
       int e = errno;
       perror_plus("write");
@@ -813,7 +790,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Establishing TLS session with %s\n", ip);
+    fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
   if(quit_now){
@@ -839,7 +816,7 @@
   
   if(ret != GNUTLS_E_SUCCESS){
     if(debug){
-      fprintf_plus(stderr, "*** GnuTLS Handshake failed ***\n");
+      fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
       gnutls_perror(ret);
     }
     errno = EPROTO;
@@ -849,8 +826,8 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf_plus(stderr, "Retrieving OpenPGP encrypted password from"
-		 " %s\n", ip);
+    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
+	    ip);
   }
   
   while(true){
@@ -861,7 +838,7 @@
     }
     
     buffer_capacity = incbuffer(&buffer, buffer_length,
-				buffer_capacity);
+				   buffer_capacity);
     if(buffer_capacity == 0){
       int e = errno;
       perror_plus("incbuffer");
@@ -894,16 +871,15 @@
 	  }
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
 	if(ret < 0){
-	  fprintf_plus(stderr, "*** GnuTLS Re-handshake failed "
-		       "***\n");
+	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
 	  gnutls_perror(ret);
 	  errno = EPROTO;
 	  goto mandos_end;
 	}
 	break;
       default:
-	fprintf_plus(stderr, "Unknown error while reading data from"
-		     " encrypted session with Mandos server\n");
+	fprintf(stderr, "Unknown error while reading data from"
+		" encrypted session with Mandos server\n");
 	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	errno = EIO;
 	goto mandos_end;
@@ -914,7 +890,7 @@
   }
   
   if(debug){
-    fprintf_plus(stderr, "Closing TLS session\n");
+    fprintf(stderr, "Closing TLS session\n");
   }
   
   if(quit_now){
@@ -932,7 +908,8 @@
   
   if(buffer_length > 0){
     ssize_t decrypted_buffer_size;
-    decrypted_buffer_size = pgp_packet_decrypt(buffer, buffer_length,
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
+					       buffer_length,
 					       &decrypted_buffer);
     if(decrypted_buffer_size >= 0){
       
@@ -949,8 +926,8 @@
 	if(ret == 0 and ferror(stdout)){
 	  int e = errno;
 	  if(debug){
-	    fprintf_plus(stderr, "Error writing encrypted data: %s\n",
-			 strerror(errno));
+	    fprintf(stderr, "Error writing encrypted data: %s\n",
+		    strerror(errno));
 	  }
 	  errno = e;
 	  goto mandos_end;
@@ -1013,10 +990,9 @@
   switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
-    fprintf_plus(stderr, "(Avahi Resolver) Failed to resolve service "
-		 "'%s' of type '%s' in domain '%s': %s\n", name, type,
-		 domain,
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
+	    " of type '%s' in domain '%s': %s\n", name, type, domain,
+	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -1024,20 +1000,17 @@
       char ip[AVAHI_ADDRESS_STR_MAX];
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
-	fprintf_plus(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		     PRIdMAX ") on port %" PRIu16 "\n", name,
-		     host_name, ip, (intmax_t)interface, port);
+	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
+		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
+		ip, (intmax_t)interface, port);
       }
       int ret = start_mandos_communication(ip, port, interface,
 					   avahi_proto_to_af(proto));
       if(ret == 0){
 	avahi_simple_poll_quit(mc.simple_poll);
       } else {
-	if(not add_server(ip, port, interface,
-			  avahi_proto_to_af(proto))){
-	  fprintf_plus(stderr, "Failed to add server \"%s\" to server"
-		       " list\n", name);
-	}
+	ret = add_server(ip, port, interface,
+			 avahi_proto_to_af(proto));
       }
     }
   }
@@ -1067,8 +1040,8 @@
   default:
   case AVAHI_BROWSER_FAILURE:
     
-    fprintf_plus(stderr, "(Avahi browser) %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "(Avahi browser) %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     avahi_simple_poll_quit(mc.simple_poll);
     return;
     
@@ -1081,9 +1054,8 @@
     if(avahi_s_service_resolver_new(mc.server, interface, protocol,
 				    name, type, domain, protocol, 0,
 				    resolve_callback, NULL) == NULL)
-      fprintf_plus(stderr, "Avahi: Failed to resolve service '%s':"
-		   " %s\n", name,
-		   avahi_strerror(avahi_server_errno(mc.server)));
+      fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
+	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -1092,8 +1064,7 @@
   case AVAHI_BROWSER_ALL_FOR_NOW:
   case AVAHI_BROWSER_CACHE_EXHAUSTED:
     if(debug){
-      fprintf_plus(stderr, "No Mandos server found, still"
-		   " searching...\n");
+      fprintf(stderr, "No Mandos server found, still searching...\n");
     }
     break;
   }
@@ -1114,131 +1085,107 @@
   errno = old_errno;
 }
 
-bool get_flags(const char *ifname, struct ifreq *ifr){
-  int ret;
-  
-  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(s < 0){
-    perror_plus("socket");
-    return false;
-  }
-  strcpy(ifr->ifr_name, ifname);
-  ret = ioctl(s, SIOCGIFFLAGS, ifr);
-  if(ret == -1){
+/* 
+ * This function determines if a directory entry in /sys/class/net
+ * corresponds to an acceptable network device.
+ * (This function is passed to scandir(3) as a filter function.)
+ */
+int good_interface(const struct dirent *if_entry){
+  ssize_t ssret;
+  char *flagname = NULL;
+  if(if_entry->d_name[0] == '.'){
+    return 0;
+  }
+  int ret = asprintf(&flagname, "%s/%s/flags", sys_class_net,
+		     if_entry->d_name);
+  if(ret < 0){
+    perror_plus("asprintf");
+    return 0;
+  }
+  int flags_fd = (int)TEMP_FAILURE_RETRY(open(flagname, O_RDONLY));
+  if(flags_fd == -1){
+    perror_plus("open");
+    free(flagname);
+    return 0;
+  }
+  free(flagname);
+  typedef short ifreq_flags;	/* ifreq.ifr_flags in netdevice(7) */
+  /* read line from flags_fd */
+  ssize_t to_read = 2+(sizeof(ifreq_flags)*2)+1; /* "0x1003\n" */
+  char *flagstring = malloc((size_t)to_read+1); /* +1 for final \0 */
+  flagstring[(size_t)to_read] = '\0';
+  if(flagstring == NULL){
+    perror_plus("malloc");
+    close(flags_fd);
+    return 0;
+  }
+  while(to_read > 0){
+    ssret = (ssize_t)TEMP_FAILURE_RETRY(read(flags_fd, flagstring,
+					     (size_t)to_read));
+    if(ssret == -1){
+      perror_plus("read");
+      free(flagstring);
+      close(flags_fd);
+      return 0;
+    }
+    to_read -= ssret;
+    if(ssret == 0){
+      break;
+    }
+  }
+  close(flags_fd);
+  intmax_t tmpmax;
+  char *tmp;
+  errno = 0;
+  tmpmax = strtoimax(flagstring, &tmp, 0);
+  if(errno != 0 or tmp == flagstring or (*tmp != '\0'
+					 and not (isspace(*tmp)))
+     or tmpmax != (ifreq_flags)tmpmax){
     if(debug){
-      perror_plus("ioctl SIOCGIFFLAGS");
+      fprintf(stderr, "Invalid flags \"%s\" for interface \"%s\"\n",
+	      flagstring, if_entry->d_name);
     }
-    return false;
+    free(flagstring);
+    return 0;
   }
-  return true;
-}
-
-bool good_flags(const char *ifname, const struct ifreq *ifr){
-  
+  free(flagstring);
+  ifreq_flags flags = (ifreq_flags)tmpmax;
   /* Reject the loopback device */
-  if(ifr->ifr_flags & IFF_LOOPBACK){
+  if(flags & IFF_LOOPBACK){
     if(debug){
-      fprintf_plus(stderr, "Rejecting loopback interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
+  if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
     if(debug){
-      fprintf_plus(stderr, "Accepting point-to-point interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return true;
+    return 1;
   }
   /* Otherwise, reject non-broadcast-capable devices */
-  if(not (ifr->ifr_flags & IFF_BROADCAST)){
+  if(not (flags & IFF_BROADCAST)){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-broadcast interface"
-		   " \"%s\"\n", ifname);
+      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
   /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(ifr->ifr_flags & IFF_NOARP){
+  if(flags & IFF_NOARP){
     if(debug){
-      fprintf_plus(stderr, "Rejecting non-ARP interface \"%s\"\n",
-		   ifname);
+      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n",
+	      if_entry->d_name);
     }
-    return false;
+    return 0;
   }
-  
   /* Accept this device */
   if(debug){
-    fprintf_plus(stderr, "Interface \"%s\" is good\n", ifname);
-  }
-  return true;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int good_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  return 1;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device which is up.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int up_interface(const struct dirent *if_entry){
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  
-  struct ifreq ifr;
-  if(not get_flags(if_entry->d_name, &ifr)){
-    if(debug){
-      fprintf_plus(stderr, "Failed to get flags for interface "
-		   "\"%s\"\n", if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject down interfaces */
-  if(not (ifr.ifr_flags & IFF_UP)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting down interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  /* Reject non-running interfaces */
-  if(not (ifr.ifr_flags & IFF_RUNNING)){
-    if(debug){
-      fprintf_plus(stderr, "Rejecting non-running interface \"%s\"\n",
-		   if_entry->d_name);
-    }
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
+    fprintf(stderr, "Interface \"%s\" is acceptable\n",
+	    if_entry->d_name);
   }
   return 1;
 }
@@ -1254,67 +1201,6 @@
   return 1;
 }
 
-/* Is this directory entry a runnable program? */
-int runnable_hook(const struct dirent *direntry){
-  int ret;
-  size_t sret;
-  struct stat st;
-  
-  if((direntry->d_name)[0] == '\0'){
-    /* Empty name? */
-    return 0;
-  }
-  
-  sret = strspn(direntry->d_name, "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
-		"abcdefghijklmnopqrstuvwxyz"
-		"0123456789"
-		"_-");
-  if((direntry->d_name)[sret] != '\0'){
-    /* Contains non-allowed characters */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" with bad name\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  
-  char *fullname = NULL;
-  ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-  if(ret < 0){
-    perror_plus("asprintf");
-    return 0;
-  }
-  
-  ret = stat(fullname, &st);
-  if(ret == -1){
-    if(debug){
-      perror_plus("Could not stat hook");
-    }
-    return 0;
-  }
-  if(not (S_ISREG(st.st_mode))){
-    /* Not a regular file */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not a file\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
-    /* Not executable */
-    if(debug){
-      fprintf_plus(stderr, "Ignoring hook \"%s\" - not executable\n",
-		   direntry->d_name);
-    }
-    return 0;
-  }
-  if(debug){
-    fprintf_plus(stderr, "Hook \"%s\" is acceptable\n",
-		 direntry->d_name);
-  }
-  return 1;
-}
-
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
@@ -1324,14 +1210,14 @@
   while(true){
     if(mc.current_server == NULL){
       if (debug){
-	fprintf_plus(stderr, "Wait until first server is found."
-		     " No timeout!\n");
+	fprintf(stderr,
+		"Wait until first server is found. No timeout!\n");
       }
       ret = avahi_simple_poll_iterate(s, -1);
     } else {
       if (debug){
-	fprintf_plus(stderr, "Check current_server if we should run"
-		     " it, or wait\n");
+	fprintf(stderr, "Check current_server if we should run it,"
+		" or wait\n");
       }
       /* the current time */
       ret = clock_gettime(CLOCK_MONOTONIC, &now);
@@ -1353,8 +1239,7 @@
 		    - ((intmax_t)waited_time.tv_nsec / 1000000));
       
       if (debug){
-	fprintf_plus(stderr, "Blocking for %" PRIdMAX " ms\n",
-		     block_time);
+	fprintf(stderr, "Blocking for %" PRIdMAX " ms\n", block_time);
       }
       
       if(block_time <= 0){
@@ -1380,149 +1265,13 @@
       ret = avahi_simple_poll_iterate(s, (int)block_time);
     }
     if(ret != 0){
-      if (ret > 0 or errno != EINTR){
+      if (ret > 0 or errno != EINTR) {
 	return (ret != 1) ? ret : 0;
       }
     }
   }
 }
 
-bool run_network_hooks(const char *mode, const char *interface,
-		       const float delay){
-  struct dirent **direntries;
-  struct dirent *direntry;
-  int ret;
-  int numhooks = scandir(hookdir, &direntries, runnable_hook,
-			 alphasort);
-  if(numhooks == -1){
-    perror_plus("scandir");
-  } else {
-    int devnull = open("/dev/null", O_RDONLY);
-    for(int i = 0; i < numhooks; i++){
-      direntry = direntries[i];
-      char *fullname = NULL;
-      ret = asprintf(&fullname, "%s/%s", hookdir, direntry->d_name);
-      if(ret < 0){
-	perror_plus("asprintf");
-	continue;
-      }
-      if(debug){
-	fprintf_plus(stderr, "Running network hook \"%s\"\n",
-		     direntry->d_name);
-      }
-      pid_t hook_pid = fork();
-      if(hook_pid == 0){
-	/* Child */
-	/* Raise privileges */
-	errno = 0;
-	ret = seteuid(0);
-	if(ret == -1){
-	  perror_plus("seteuid");
-	}
-	/* Raise privileges even more */
-	errno = 0;
-	ret = setuid(0);
-	if(ret == -1){
-	  perror_plus("setuid");
-	}
-	/* Set group */
-	errno = 0;
-	ret = setgid(0);
-	if(ret == -1){
-	  perror_plus("setgid");
-	}
-	/* Reset supplementary groups */
-	errno = 0;
-	ret = setgroups(0, NULL);
-	if(ret == -1){
-	  perror_plus("setgroups");
-	}
-	dup2(devnull, STDIN_FILENO);
-	close(devnull);
-	dup2(STDERR_FILENO, STDOUT_FILENO);
-	ret = setenv("MANDOSNETHOOKDIR", hookdir, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-	ret = setenv("DEVICE", interface, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-	ret = setenv("VERBOSE", debug ? "1" : "0", 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-	ret = setenv("MODE", mode, 1);
-	if(ret == -1){
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-	char *delaystring;
-	ret = asprintf(&delaystring, "%f", delay);
-	if(ret == -1){
-	  perror_plus("asprintf");
-	  _exit(EX_OSERR);
-	}
-	ret = setenv("DELAY", delaystring, 1);
-	if(ret == -1){
-	  free(delaystring);
-	  perror_plus("setenv");
-	  _exit(EX_OSERR);
-	}
-	free(delaystring);
-	if(connect_to != NULL){
-	  ret = setenv("CONNECT", connect_to);
-	  if(ret == -1){
-	    perror_plus("setenv");
-	    _exit(EX_OSERR);
-	  }
-	}
-	if(execl(fullname, direntry->d_name, mode, NULL) == -1){
-	  perror_plus("execl");
-	  _exit(EXIT_FAILURE);
-	}
-      } else {
-	int status;
-	if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
-	  perror_plus("waitpid");
-	  free(fullname);
-	  continue;
-	}
-	if(WIFEXITED(status)){
-	  if(WEXITSTATUS(status) != 0){
-	    fprintf_plus(stderr, "Warning: network hook \"%s\" exited"
-			 " with status %d\n", direntry->d_name,
-			 WEXITSTATUS(status));
-	    free(fullname);
-	    continue;
-	  }
-	} else if(WIFSIGNALED(status)){
-	  fprintf_plus(stderr, "Warning: network hook \"%s\" died by"
-		       " signal %d\n", direntry->d_name,
-		       WTERMSIG(status));
-	  free(fullname);
-	  continue;
-	} else {
-	  fprintf_plus(stderr, "Warning: network hook \"%s\""
-		       " crashed\n", direntry->d_name);
-	  free(fullname);
-	  continue;
-	}
-      }
-      free(fullname);
-      if(debug){
-	fprintf_plus(stderr, "Network hook \"%s\" ran successfully\n",
-		     direntry->d_name);
-      }
-    }
-    close(devnull);
-  }
-  return true;
-}
-
 int main(int argc, char *argv[]){
   AvahiSServiceBrowser *sb = NULL;
   int error;
@@ -1608,11 +1357,7 @@
 	.group = 2 },
       { .name = "retry", .key = 132,
 	.arg = "SECONDS",
-	.doc = "Retry interval used when denied by the Mandos server",
-	.group = 2 },
-      { .name = "network-hook-dir", .key = 133,
-	.arg = "DIR",
-	.doc = "Directory where network hooks are located",
+	.doc = "Retry interval used when denied by the mandos server",
 	.group = 2 },
       /*
        * These reproduce what we would get without ARGP_NO_HELP
@@ -1672,9 +1417,6 @@
 	  argp_error(state, "Bad retry interval");
 	}
 	break;
-      case 133:			/* --network-hook-dir */
-	hookdir = arg;
-	break;
 	/*
 	 * These reproduce what we would get without ARGP_NO_HELP
 	 */
@@ -1686,7 +1428,7 @@
 	argp_state_help(state, state->out_stream,
 			ARGP_HELP_USAGE | ARGP_HELP_EXIT_ERR);
       case 'V':			/* --version */
-	fprintf_plus(state->out_stream, "%s\n", argp_program_version);
+	fprintf(state->out_stream, "%s\n", argp_program_version);
 	exit(argp_err_exit_status);
 	break;
       default:
@@ -1719,91 +1461,76 @@
   {
     /* Work around Debian bug #633582:
        <http://bugs.debian.org/633582> */
+    struct stat st;
     
     /* Re-raise priviliges */
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
       perror_plus("seteuid");
-    } else {
-      struct stat st;
-      
-      if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
-	int seckey_fd = open(seckey, O_RDONLY);
-	if(seckey_fd == -1){
-	  perror_plus("open");
-	} else {
-	  ret = (int)TEMP_FAILURE_RETRY(fstat(seckey_fd, &st));
-	  if(ret == -1){
-	    perror_plus("fstat");
-	  } else {
-	    if(S_ISREG(st.st_mode)
-	       and st.st_uid == 0 and st.st_gid == 0){
-	      ret = fchown(seckey_fd, uid, gid);
-	      if(ret == -1){
-		perror_plus("fchown");
-	      }
-	    }
-	  }
-	  TEMP_FAILURE_RETRY(close(seckey_fd));
-	}
-      }
-    
-      if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
-	int pubkey_fd = open(pubkey, O_RDONLY);
-	if(pubkey_fd == -1){
-	  perror_plus("open");
-	} else {
-	  ret = (int)TEMP_FAILURE_RETRY(fstat(pubkey_fd, &st));
-	  if(ret == -1){
-	    perror_plus("fstat");
-	  } else {
-	    if(S_ISREG(st.st_mode)
-	       and st.st_uid == 0 and st.st_gid == 0){
-	      ret = fchown(pubkey_fd, uid, gid);
-	      if(ret == -1){
-		perror_plus("fchown");
-	      }
-	    }
-	  }
-	  TEMP_FAILURE_RETRY(close(pubkey_fd));
-	}
-      }
-    
-      /* Lower privileges */
-      errno = 0;
-      ret = seteuid(uid);
-      if(ret == -1){
-	perror_plus("seteuid");
-      }
-    }
-  }
-  
-  /* Run network hooks */
-  if(not run_network_hooks("start", interface, delay)){
-    goto end;
+    }
+    
+    if(strcmp(seckey, PATHDIR "/" SECKEY) == 0){
+      int seckey_fd = open(seckey, O_RDONLY);
+      if(seckey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(seckey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(seckey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(seckey_fd));
+      }
+    }
+    
+    if(strcmp(pubkey, PATHDIR "/" PUBKEY) == 0){
+      int pubkey_fd = open(pubkey, O_RDONLY);
+      if(pubkey_fd == -1){
+	perror_plus("open");
+      } else {
+	ret = (int)TEMP_FAILURE_RETRY(fstat(pubkey_fd, &st));
+	if(ret == -1){
+	  perror_plus("fstat");
+	} else {
+	  if(S_ISREG(st.st_mode) and st.st_uid == 0 and st.st_gid == 0){
+	    ret = fchown(pubkey_fd, uid, gid);
+	    if(ret == -1){
+	      perror_plus("fchown");
+	    }
+	  }
+	}
+	TEMP_FAILURE_RETRY(close(pubkey_fd));
+      }
+    }
+    
+    /* Lower privileges */
+    errno = 0;
+    ret = seteuid(uid);
+    if(ret == -1){
+      perror_plus("seteuid");
+    }
   }
   
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-  
+
   if(interface[0] == '\0'){
     struct dirent **direntries;
-    /* First look for interfaces that are up */
-    ret = scandir(sys_class_net, &direntries, up_interface,
+    ret = scandir(sys_class_net, &direntries, good_interface,
 		  alphasort);
-    if(ret == 0){
-      /* No up interfaces, look for any good interfaces */
-      free(direntries);
-      ret = scandir(sys_class_net, &direntries, good_interface,
-		    alphasort);
-    }
     if(ret >= 1){
-      /* Pick the first interface returned */
+      /* Pick the first good interface */
       interface = strdup(direntries[0]->d_name);
       if(debug){
-	fprintf_plus(stderr, "Using interface \"%s\"\n", interface);
+	fprintf(stderr, "Using interface \"%s\"\n", interface);
       }
       if(interface == NULL){
 	perror_plus("malloc");
@@ -1814,7 +1541,7 @@
       free(direntries);
     } else {
       free(direntries);
-      fprintf_plus(stderr, "Could not find a network interface\n");
+      fprintf(stderr, "Could not find a network interface\n");
       exitcode = EXIT_FAILURE;
       goto end;
     }
@@ -1826,8 +1553,7 @@
   srand((unsigned int) time(NULL));
   mc.simple_poll = avahi_simple_poll_new();
   if(mc.simple_poll == NULL){
-    fprintf_plus(stderr,
-		 "Avahi: Failed to create simple poll object.\n");
+    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -1899,7 +1625,7 @@
   if(strcmp(interface, "none") != 0){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
-      fprintf_plus(stderr, "No such interface: \"%s\"\n", interface);
+      fprintf(stderr, "No such interface: \"%s\"\n", interface);
       exitcode = EX_UNAVAILABLE;
       goto end;
     }
@@ -2025,10 +1751,18 @@
 #endif	/* __linux__ */
     /* Lower privileges */
     errno = 0;
-    /* Lower privileges */
-    ret = seteuid(uid);
-    if(ret == -1){
-      perror_plus("seteuid");
+    if(take_down_interface){
+      /* Lower privileges */
+      ret = seteuid(uid);
+      if(ret == -1){
+	perror_plus("seteuid");
+      }
+    } else {
+      /* Lower privileges permanently */
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
   
@@ -2038,7 +1772,7 @@
   
   ret = init_gnutls_global(pubkey, seckey);
   if(ret == -1){
-    fprintf_plus(stderr, "init_gnutls_global failed\n");
+    fprintf(stderr, "init_gnutls_global failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2060,7 +1794,7 @@
   }
   
   if(not init_gpgme(pubkey, seckey, tempdir)){
-    fprintf_plus(stderr, "init_gpgme failed\n");
+    fprintf(stderr, "init_gpgme failed\n");
     exitcode = EX_UNAVAILABLE;
     goto end;
   } else {
@@ -2076,7 +1810,7 @@
     /* (Mainly meant for debugging) */
     char *address = strrchr(connect_to, ':');
     if(address == NULL){
-      fprintf_plus(stderr, "No colon in address\n");
+      fprintf(stderr, "No colon in address\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2090,7 +1824,7 @@
     tmpmax = strtoimax(address+1, &tmp, 10);
     if(errno != 0 or tmp == address+1 or *tmp != '\0'
        or tmpmax != (uint16_t)tmpmax){
-      fprintf_plus(stderr, "Bad port number\n");
+      fprintf(stderr, "Bad port number\n");
       exitcode = EX_USAGE;
       goto end;
     }
@@ -2126,8 +1860,8 @@
 	break;
       }
       if(debug){
-	fprintf_plus(stderr, "Retrying in %d seconds\n",
-		     (int)retry_interval);
+	fprintf(stderr, "Retrying in %d seconds\n",
+		(int)retry_interval);
       }
       sleep((int)retry_interval);
     }
@@ -2135,7 +1869,7 @@
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-    
+
     goto end;
   }
   
@@ -2163,8 +1897,8 @@
   
   /* Check if creating the Avahi server object succeeded */
   if(mc.server == NULL){
-    fprintf_plus(stderr, "Failed to create Avahi server: %s\n",
-		 avahi_strerror(error));
+    fprintf(stderr, "Failed to create Avahi server: %s\n",
+	    avahi_strerror(error));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2178,8 +1912,8 @@
 				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
 				   NULL, 0, browse_callback, NULL);
   if(sb == NULL){
-    fprintf_plus(stderr, "Failed to create service browser: %s\n",
-		 avahi_strerror(avahi_server_errno(mc.server)));
+    fprintf(stderr, "Failed to create service browser: %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
     exitcode = EX_UNAVAILABLE;
     goto end;
   }
@@ -2191,20 +1925,20 @@
   /* Run the main loop */
   
   if(debug){
-    fprintf_plus(stderr, "Starting Avahi loop search\n");
+    fprintf(stderr, "Starting Avahi loop search\n");
   }
 
   ret = avahi_loop_with_timeout(mc.simple_poll,
 				(int)(retry_interval * 1000));
   if(debug){
-    fprintf_plus(stderr, "avahi_loop_with_timeout exited %s\n",
-		 (ret == 0) ? "successfully" : "with error");
+    fprintf(stderr, "avahi_loop_with_timeout exited %s\n",
+	    (ret == 0) ? "successfully" : "with error");
   }
   
  end:
   
   if(debug){
-    fprintf_plus(stderr, "%s exiting\n", argv[0]);
+    fprintf(stderr, "%s exiting\n", argv[0]);
   }
   
   /* Cleanup things */
@@ -2226,7 +1960,7 @@
   if(gpgme_initialized){
     gpgme_release(mc.ctx);
   }
-  
+
   /* Cleans up the circular linked list of Mandos servers the client
      has seen */
   if(mc.current_server != NULL){
@@ -2238,23 +1972,19 @@
     }
   }
   
-  /* Run network hooks */
-  run_network_hooks("stop", interface, delay);
-  
-  /* Re-raise priviliges */
-  {
+  /* Take down the network interface */
+  if(take_down_interface){
+    /* Re-raise priviliges */
     errno = 0;
     ret = seteuid(0);
     if(ret == -1){
       perror_plus("seteuid");
     }
-    
-    /* Take down the network interface */
-    if(take_down_interface and geteuid() == 0){
+    if(geteuid() == 0){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror_plus("ioctl SIOCGIFFLAGS");
-      } else if(network.ifr_flags & IFF_UP){
+      } else if(network.ifr_flags & IFF_UP) {
 	network.ifr_flags &= ~(short)IFF_UP; /* clear flag */
 	ret = ioctl(sd, SIOCSIFFLAGS, &network);
 	if(ret == -1){
@@ -2265,14 +1995,14 @@
       if(ret == -1){
 	perror_plus("close");
       }
+      /* Lower privileges permanently */
+      errno = 0;
+      ret = setuid(uid);
+      if(ret == -1){
+	perror_plus("setuid");
+      }
     }
   }
-  /* Lower privileges permanently */
-  errno = 0;
-  ret = setuid(uid);
-  if(ret == -1){
-    perror_plus("setuid");
-  }
   
   /* Removes the GPGME temp directory and all files inside */
   if(tempdir_created){
@@ -2292,8 +2022,8 @@
 	}
 	ret = remove(fullname);
 	if(ret == -1){
-	  fprintf_plus(stderr, "remove(\"%s\"): %s\n", fullname,
-		       strerror(errno));
+	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
+		  strerror(errno));
 	}
 	free(fullname);
       }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2011-12-27 03:56:39 +0000
+++ plugins.d/mandos-client.xml	2011-10-05 16:00:56 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2011-11-27">
+<!ENTITY TIMESTAMP "2011-10-03">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -102,11 +102,6 @@
       </arg>
       <sbr/>
       <arg>
-	<option>--network-hook-dir
-	<replaceable>DIR</replaceable></option>
-      </arg>
-      <sbr/>
-      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -148,26 +143,6 @@
       will wait indefinitely for new servers to appear.
     </para>
     <para>
-      The network interface is selected like this: If an interface is
-      specified using the <option>--interface</option> option, that
-      interface is used.  Otherwise, <command>&COMMANDNAME;</command>
-      will choose any interface that is up and running and is not a
-      loopback interface, is not a point-to-point interface, is
-      capable of broadcasting and does not have the NOARP flag (see
-      <citerefentry><refentrytitle>netdevice</refentrytitle>
-      <manvolnum>7</manvolnum></citerefentry>).  (If the
-      <option>--connect</option> option is used, point-to-point
-      interfaces and non-broadcast interfaces are accepted.)  If no
-      acceptable interfaces are found, re-run the check but without
-      the <quote>up and running</quote> requirement, and manually take
-      the selected interface up (and later take it down on program
-      exit).
-    </para>
-    <para>
-      Before a network interface is selected, all <quote>network
-      hooks</quote> are run; see <xref linkend="network-hooks"/>.
-    </para>
-    <para>
       This program is not meant to be run directly; it is really meant
       to run as a plugin of the <application>Mandos</application>
       <citerefentry><refentrytitle>plugin-runner</refentrytitle>
@@ -248,8 +223,7 @@
 	    can not be a pseudo-interface such as <quote>br0</quote>
 	    or <quote>tun0</quote>; such interfaces will not exist
 	    until much later in the boot process, and can not be used
-	    by this program, unless created by a <quote>network
-	    hook</quote> — see <xref linkend="network-hooks"/>.
+	    by this program.
 	  </para>
 	  <para>
 	    <replaceable>NAME</replaceable> can be the string
@@ -337,18 +311,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-
-      <varlistentry>
-	<term><option>--network-hook-dir=<replaceable
-	>DIR</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Network hook directory.  The default directory is
-	    <quote><filename class="directory"
-	    >/lib/mandos/network-hooks.d</filename></quote>.
-	  </para>
-	</listitem>
-      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>
@@ -415,10 +377,8 @@
       <refentrytitle>plugin-runner</refentrytitle>
       <manvolnum>8mandos</manvolnum></citerefentry>) is used to run
       both this program and others in in parallel,
-      <emphasis>one</emphasis> of which (<citerefentry>
-      <refentrytitle>password-prompt</refentrytitle>
-      <manvolnum>8mandos</manvolnum></citerefentry>) will prompt for
-      passwords on the system console.
+      <emphasis>one</emphasis> of which will prompt for passwords on
+      the system console.
     </para>
   </refsect1>
   
@@ -445,174 +405,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="network-hooks">
-    <title>NETWORK HOOKS</title>
-    <para>
-      If a network interface like a bridge or tunnel is required to
-      find a Mandos server, this requires the interface to be up and
-      running before <command>&COMMANDNAME;</command> starts looking
-      for Mandos servers.  This can be accomplished by creating a
-      <quote>network hook</quote> program, and placing it in a special
-      directory.
-    </para>
-    <para>
-      Before the network is used (and again before program exit), any
-      runnable programs found in the network hook directory are run
-      with the argument <quote><literal>start</literal></quote> or
-      <quote><literal>stop</literal></quote>.  This should bring up or
-      down, respectively, any network interface which
-      <command>&COMMANDNAME;</command> should use.
-    </para>
-    <refsect2 id="hook-requirements">
-      <title>REQUIREMENTS</title>
-      <para>
-	A network hook must be an executable file, and its name must
-	consist entirely of upper and lower case letters, digits,
-	underscores, periods, and hyphens.
-      </para>
-      <para>
-	A network hook will receive one argument, which can be one of
-	the following:
-      </para>
-      <variablelist>
-	<varlistentry>
-	  <term><literal>start</literal></term>
-	  <listitem>
-	    <para>
-	      This should make the network hook create (if necessary)
-	      and bring up a network interface.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><literal>stop</literal></term>
-	  <listitem>
-	    <para>
-	      This should make the network hook take down a network
-	      interface, and delete it if it did not exist previously.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><literal>files</literal></term>
-	  <listitem>
-	    <para>
-	      This should make the network hook print, <emphasis>one
-	      file per line</emphasis>, all the files needed for it to
-	      run.  (These files will be copied into the initial RAM
-	      filesystem.)  Typical use is for a network hook which is
-	      a shell script to print its needed binaries.
-	    </para>
-	    <para>
-	      It is not necessary to print any non-executable files
-	      already in the network hook directory, these will be
-	      copied implicitly if they otherwise satisfy the name
-	      requirement.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><literal>modules</literal></term>
-	  <listitem>
-	    <para>
-	      This should make the network hook print, <emphasis>on
-	      separate lines</emphasis>, all the kernel modules needed
-	      for it to run.  (These modules will be copied into the
-	      initial RAM filesystem.)  For instance, a tunnel
-	      interface needs the
-	      <quote><literal>tun</literal></quote> module.
-	    </para>
-	  </listitem>
-	</varlistentry>
-      </variablelist>
-      <para>
-	The network hook will be provided with a number of environment
-	variables:
-      </para>
-      <variablelist>
-	<varlistentry>
-	  <term><envar>MANDOSNETHOOKDIR</envar></term>
-	  <listitem>
-	    <para>
-	      The network hook directory, specified to
-	      <command>&COMMANDNAME;</command> by the
-	      <option>--network-hook-dir</option> option.  Note: this
-	      should <emphasis>always</emphasis> be used by the
-	      network hook to refer to itself or any files in the hook
-	      directory it may require.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>DEVICE</envar></term>
-	  <listitem>
-	    <para>
-	      The network interface, as specified to
-	      <command>&COMMANDNAME;</command> by the
-	      <option>--interface</option> option.  If this is not the
-	      interface a hook will bring up, there is no reason for a
-	      hook to continue.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>MODE</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the first argument;
-	      i.e. <quote><literal>start</literal></quote>,
-	      <quote><literal>stop</literal></quote>,
-	      <quote><literal>files</literal></quote>, or
-	      <quote><literal>modules</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>VERBOSITY</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the <quote><literal>1</literal></quote> if
-	      the <option>--debug</option> option is passed to
-	      <command>&COMMANDNAME;</command>, otherwise
-	      <quote><literal>0</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>DELAY</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the <option>--delay</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-	<varlistentry>
-	  <term><envar>CONNECT</envar></term>
-	  <listitem>
-	    <para>
-	      This will be the same as the <option>--connect</option>
-	      option passed to <command>&COMMANDNAME;</command>.  Is
-	      only set if <option>--connect</option> is passed and
-	      <envar>MODE</envar> is
-	      <quote><literal>start</literal></quote> or
-	      <quote><literal>stop</literal></quote>.
-	    </para>
-	  </listitem>
-	</varlistentry>
-      </variablelist>
-      <para>
-	A hook may not read from standard input, and should be
-	restrictive in printing to standard output or standard error
-	unless <varname>VERBOSITY</varname> is
-	<quote><literal>1</literal></quote>.
-      </para>
-    </refsect2>
-  </refsect1>
-  
   <refsect1 id="files">
     <title>FILES</title>
     <variablelist>
@@ -630,17 +422,6 @@
 	  </para>
 	</listitem>
       </varlistentry>
-      <varlistentry>
-	<term><filename
-	class="directory">/lib/mandos/network-hooks.d</filename></term>
-	<listitem>
-	  <para>
-	    Directory where network hooks are located.  Change this
-	    with the <option>--network-hook-dir</option> option.  See
-	    <xref linkend="network-hooks"/>.
-	  </para>
-	</listitem>
-      </varlistentry>
     </variablelist>
   </refsect1>
   

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2011-12-25 00:40:09 +0000
+++ plugins.d/password-prompt.c	2011-10-09 12:32:13 +0000
@@ -72,18 +72,7 @@
 /* Needed for conflict resolution */
 const char plymouth_name[] = "plymouthd";
 
-__attribute__((format (gnu_printf, 2, 3), nonnull(1)))
-int fprintf_plus(FILE *stream, const char *format, ...){
-  va_list ap;
-  va_start (ap, format);
-  
-  TEMP_FAILURE_RETRY(fprintf(stream, "Mandos plugin %s: ",
-			     program_invocation_short_name));
-  return TEMP_FAILURE_RETRY(vfprintf(stream, format, ap));
-}
-
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -96,7 +85,8 @@
     fprintf(stderr, "Mandos plugin %s: ",
 	    program_invocation_short_name);
     vfprintf(stderr, formatstring, ap);
-    fprintf(stderr, ": %s\n", strerror(errnum));
+    fprintf(stderr, ": ");
+    fprintf(stderr, "%s\n", strerror(errnum));
     error(status, errno, "vasprintf while printing error");
     return;
   }
@@ -119,7 +109,6 @@
      from the terminal.  Password-prompt will exit if it detects
      plymouth since plymouth performs the same functionality.
    */
-  __attribute__((nonnull))
   int is_plymouth(const struct dirent *proc_entry){
     int ret;
     int cl_fd;
@@ -139,7 +128,7 @@
     ret = asprintf(&cmdline_filename, "/proc/%s/cmdline",
 		   proc_entry->d_name);
     if(ret == -1){
-      error_plus(0, errno, "asprintf");
+      error(0, errno, "asprintf");
       return 0;
     }
     
@@ -148,7 +137,7 @@
     free(cmdline_filename);
     if(cl_fd == -1){
       if(errno != ENOENT){
-	error_plus(0, errno, "open");
+	error(0, errno, "open");
       }
       return 0;
     }
@@ -165,7 +154,7 @@
 	if(cmdline_len + blocksize + 1 > cmdline_allocated){
 	  tmp = realloc(cmdline, cmdline_allocated + blocksize + 1);
 	  if(tmp == NULL){
-	    error_plus(0, errno, "realloc");
+	    error(0, errno, "realloc");
 	    free(cmdline);
 	    close(cl_fd);
 	    return 0;
@@ -178,7 +167,7 @@
 	sret = read(cl_fd, cmdline + cmdline_len,
 		    cmdline_allocated - cmdline_len);
 	if(sret == -1){
-	  error_plus(0, errno, "read");
+	  error(0, errno, "read");
 	  free(cmdline);
 	  close(cl_fd);
 	  return 0;
@@ -187,7 +176,7 @@
       } while(sret != 0);
       ret = close(cl_fd);
       if(ret == -1){
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	free(cmdline);
 	return 0;
       }
@@ -223,7 +212,7 @@
   int ret;
   ret = scandir("/proc", &direntries, is_plymouth, alphasort);
   if (ret == -1){
-    error_plus(1, errno, "scandir");
+    error(1, errno, "scandir");
   }
   free(direntries);
   return ret > 0;
@@ -260,7 +249,6 @@
       { .name = NULL }
     };
     
-    __attribute__((nonnull(3)))
     error_t parse_opt (int key, char *arg, struct argp_state *state){
       errno = 0;
       switch (key){
@@ -302,7 +290,7 @@
     case ENOMEM:
     default:
       errno = ret;
-      error_plus(0, errno, "argp_parse");
+      error(0, errno, "argp_parse");
       return EX_OSERR;
     case EINVAL:
       return EX_USAGE;
@@ -326,7 +314,7 @@
   
   if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     int e = errno;
-    error_plus(0, errno, "tcgetattr");
+    error(0, errno, "tcgetattr");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -339,17 +327,17 @@
   sigemptyset(&new_action.sa_mask);
   ret = sigaddset(&new_action.sa_mask, SIGINT);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGHUP);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   ret = sigaddset(&new_action.sa_mask, SIGTERM);
   if(ret == -1){
-    error_plus(0, errno, "sigaddset");
+    error(0, errno, "sigaddset");
     return EX_OSERR;
   }
   /* Need to check if the handler is SIG_IGN before handling:
@@ -358,37 +346,37 @@
   */
   ret = sigaction(SIGINT, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGHUP, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
   ret = sigaction(SIGTERM, NULL, &old_action);
   if(ret == -1){
-    error_plus(0, errno, "sigaction");
+    error(0, errno, "sigaction");
     return EX_OSERR;
   }
   if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
       return EX_OSERR;
     }
   }
@@ -402,7 +390,7 @@
   t_new.c_lflag &= ~(tcflag_t)ECHO;
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     int e = errno;
-    error_plus(0, errno, "tcsetattr-echo");
+    error(0, errno, "tcsetattr-echo");
     switch(e){
     case EBADF:
     case ENOTTY:
@@ -472,7 +460,7 @@
 	sret = write(STDOUT_FILENO, buffer + written, n - written);
 	if(sret < 0){
 	  int e = errno;
-	  error_plus(0, errno, "write");
+	  error(0, errno, "write");
 	  switch(e){
 	  case EBADF:
 	  case EFAULT:
@@ -494,7 +482,7 @@
       sret = close(STDOUT_FILENO);
       if(sret == -1){
 	int e = errno;
-	error_plus(0, errno, "close");
+	error(0, errno, "close");
 	switch(e){
 	case EBADF:
 	  status = EX_OSFILE;
@@ -510,7 +498,7 @@
     if(sret < 0){
       int e = errno;
       if(errno != EINTR and not feof(stdin)){
-	error_plus(0, errno, "getline");
+	error(0, errno, "getline");
 	switch(e){
 	case EBADF:
 	  status = EX_UNAVAILABLE;
@@ -539,7 +527,7 @@
     fprintf(stderr, "Restoring terminal attributes\n");
   }
   if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
-    error_plus(0, errno, "tcsetattr+echo");
+    error(0, errno, "tcsetattr+echo");
   }
   
   if(quit_now){
@@ -547,7 +535,7 @@
     old_action.sa_handler = SIG_DFL;
     ret = sigaction(signal_received, &old_action, NULL);
     if(ret == -1){
-      error_plus(0, errno, "sigaction");
+      error(0, errno, "sigaction");
     }
     raise(signal_received);
   }

=== modified file 'plugins.d/plymouth.c'
--- plugins.d/plymouth.c	2011-12-25 00:40:09 +0000
+++ plugins.d/plymouth.c	2011-10-05 16:00:56 +0000
@@ -75,7 +75,6 @@
 }
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;
@@ -154,7 +153,6 @@
   return true;
 }
 
-__attribute__((nonnull (2, 3)))
 bool exec_and_wait(pid_t *pid_return, const char *path,
 		   const char **argv, bool interruptable,
 		   bool daemonize){
@@ -214,7 +212,6 @@
   return false;
 }
 
-__attribute__((nonnull))
 int is_plymouth(const struct dirent *proc_entry){
   int ret;
   {

=== modified file 'plugins.d/plymouth.xml'
--- plugins.d/plymouth.xml	2011-11-12 18:14:55 +0000
+++ plugins.d/plymouth.xml	2011-10-05 16:00:56 +0000
@@ -161,7 +161,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/proc</filename></term>
+	<term><filename>/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2011-12-24 23:17:02 +0000
+++ plugins.d/splashy.c	2011-10-05 16:00:56 +0000
@@ -61,7 +61,6 @@
 int signal_received;
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2011-12-24 23:17:02 +0000
+++ plugins.d/usplash.c	2011-10-05 16:00:56 +0000
@@ -58,7 +58,6 @@
 const char usplash_name[] = "/sbin/usplash";
 
 /* Function to use when printing errors */
-__attribute__((format (gnu_printf, 3, 4)))
 void error_plus(int status, int errnum, const char *formatstring,
 		...){
   va_list ap;

=== modified file 'plugins.d/usplash.xml'
--- plugins.d/usplash.xml	2011-11-12 18:14:55 +0000
+++ plugins.d/usplash.xml	2011-10-05 16:00:56 +0000
@@ -178,7 +178,7 @@
 	</listitem>
       </varlistentry>
       <varlistentry>
-	<term><filename class="directory">/proc</filename></term>
+	<term><filename>/proc</filename></term>
 	<listitem>
 	  <para>
 	    To find the running <citerefentry><refentrytitle

